var fs = require("fs");
var https = require("https");
var path = require("path");

var options = {
	key: fs.readFileSync('./ssl.key'),
	cert:fs.readFileSync('./ssl.crt')
};

var sessions = {};
var usersInSessionLimit = 2;

var port = process.env.PORT || 4080;
if (process.argv.length == 3) {
    port = process.argv[2];
}

var serverDir = path.dirname(__filename)
var clientDir = path.join(serverDir, "");

console.log("=========serverDir:",serverDir);
console.log("=========clientDir:",clientDir);

var contentTypeMap = {
    ".html": "text/html;charset=utf-8",
    ".js": "text/javascript",
    ".css": "text/css"
};



var server = https.createServer(options, function (request, response) {
    var headers = {
        "Cache-Control": "no-cache, no-store",
        "Pragma": "no-cache",
        "Expires": "0"
    };

    var parts = request.url.split("/");

    var url = request.url.split("?", 1)[0];
    var filePath = path.join(clientDir, url);

    filePath = filePath.replace('build/shell/', ""); //mac
    filePath = filePath.replace('build\\shell\\', ""); //win


    fs.stat(filePath, function (err, stats) {
        if (err || !stats.isFile()) {
            response.writeHead(404);
            response.end("404 Not found");
            return;
        }

        var contentType = contentTypeMap[path.extname(filePath)] || "text/plain";
        response.writeHead(200, { "Content-Type": contentType });

        var readStream = fs.createReadStream(filePath);
        readStream.on("error", function () {
            response.writeHead(500);
            response.end("500 Server error");
        });
        readStream.pipe(response);
    });
});

console.log('The server is listening on port ' + port);
server.listen(port);