//本地工程环境运行时会走http协议，用dev.3tee.cn:81， nodejs环境运行时会走https协议，用dev.3tee.cn:441
// var serverURL = 'dev.3tee.cn:441';

// var serverURL = 'dev.3tee.cn:81';
// var accessKey = 'sdk2020_demo_access';
// var secretKey = 'sdk2020_demo_secret';

// 媒体服务器地址
var serverURL = 'avd.nice2meet.cn:9609';
// key
var accessKey = 'demo_access';
// 密钥
var secretKey = 'demo_secret';


// 设置token
var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random() * 9000) + 1000);
// 使用AVDEngine引擎模块
var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
// 初始化引擎
var avdEngine = new AVDEngine();

// avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
// 初始化设备
avdEngine.initDevice();
// 检查麦克风、摄像头等设备
avdEngine.checkDevice().then(checkResult).otherwise(checkError);
// 设置视频编码格式默认VP8
// avdEngine.setVideoCoding(VideoCodingType.H264);
// 创建RestApi实例
var restApi = new RestApi(serverURL);

var isRoomOwer = false;
var self = this;

var localVideo = document.getElementById("localVideo");
var remoteAudio = document.getElementById("remoteAudio");
var remoteVideo = document.getElementById("remoteVideo");
var local_video = document.getElementById("local_video");
var local_audio = document.getElementById("local_audio");
var remote_video = document.getElementById("remote_video");
var remote_audio = document.getElementById("remote_audio");

var localVideoId = '';
var localAudioId = '';
var isOpenVideoShow = true;
var isOpenAudioShow = true;

var isVideoFacility = false
var isAudioFacility = false

// 调用restApi传入key和密钥向服务器获取token
restApi.getAccessToken(accessKey, secretKey).then((res) => {
    console.log('Success', res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error", error);
    $(".promptMsg").html('getAccessToken(),error:' + error.msg);

})

function checkResult(result) {
    isVideoFacility = result.video;
    isAudioFacility = result.audio;
}

function checkError(error) {
    $(".promptMsg").html("get device error!error code:" + error.code + "; error message:" + error.message);
}

//创建房间
function createRoom() {
    var topic = 'testingMeeting';
    // 调用restApi创建房间，参数为token、会议主题、用户Id
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        console.log('Success', res)
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        console.log("Error", error)
        $(".promptMsg").html('createRoom(),error:' + error.msg);
    })
}

//  加入会议
function joinRoom() {
    if (room) { return }
    if (!isVideoFacility) {
        $('.promptMsg').html('没有摄像头设备，请插入');
    } else if (!isAudioFacility) {
        $('.promptMsg').html('没有音频设备，请插入');
    } else if ($("#first").val() == '') {
        $('.promptMsg').html('会议号不能为空，请先创建房间');
    } else {
        self.roomId = $("#first").val();
        // 初始化
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

//  初始化成功
function initSuccess() {
    // 传入房间号获取房间对象。如房间存在,直接返回，不存在时创建房间后返回
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//  初始化失败
function initError(error) {
    $(".promptMsg").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('加入会议成功');

    //  自动打开音视频
    openCamera();
    openMicrophone();

    //注册房间回调，给房间添加相应事件
    registerRoomCallback();

    //加会登陆前，会议中已经发布的视频资源,采取订阅处理
    onPublishCameraNotify(room.pubVideos);

    // 处理房间内的参会者，给每个参会者添加回调事件
    participantsHandle(room.getParticipants());

    $('.localVideo_userName').html(self.userName);
}

//  加入房间失败
function joinError(error) {
    console.log('==================joinError(),error:', error)
    if (error.code == 404) {
        $(".promptMsg").html("加会失败！原因房间没有找到，请核实。joinError(),error");
    } else {
        $(".promptMsg").html('joinError(),error:' + error.message + "[" + error.code + "]");
    }
}

/**
 * 打开摄像头
 */
function openCamera() {
    if (isOpenVideoShow) {
        isOpenVideoShow = false;
        videos = room.selfUser.videos;
        if (videos && videos.length > 0) {
            var video = videos[0];
            if (video) {
                localVideoId = video.id;
                // 预览并发布视频，传入的是放置预览视频的video元素
                video.previewAndPublish(localVideo).otherwise(showError);
                local_video.className = 'openCamera';
            }
        }
    }
}

/**
 * 关闭摄像头
 */
function closeCamera() {
    if (!isOpenVideoShow) {
        isOpenVideoShow = true;
        // 通过user.getVideo传入videoId获取video对象
        var video = room.selfUser.getVideo(self.localVideoId);
        if (video) {
            local_video.className = 'closeCamera';
            video.unpreview();
            video.unpublish();
        }
    }
}

/**
 * 打开麦克风
 */
function openMicrophone() {
    if (isOpenAudioShow) {
        isOpenAudioShow = false;
        // 获取audio对象
        var audio = room.selfUser.audio;
        localAudioId = audio.id;
        if (audio) {
            audio.openMicrophone().otherwise(showError);
            local_audio.className = 'openMicrophone';
        }
    }
}

/**
 * 关闭麦克风
 */
function closeMicrophone() {
    if (!isOpenAudioShow) {
        isOpenAudioShow = true;
        // 通过user.getAudio传入audioId获取audio对象
        var audio = room.selfUser.getAudio(self.localAudioId);
        if (audio) {
            local_audio.className = 'closeMicrophone';
            audio.closeMicrophone();
        }
    }
}

function showError(error) {
    $(".promptMsg").html('showError(),error:' + error.message + "[" + error.code + "]");
}

//退会
function leaveRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
        var reason = 1; //退会原因
        /**
         * @desc 退出会议
         * @param {int} reason - 退会原因
         * @param {boolean} kickoffOpt - 退会类型： true:被踢退会，false:主动退会，可以不填
         */
        room.leave(reason).then(function () {
            top.location = "index.html";
            return false;
        });
    }
}

//注册房间回调
function registerRoomCallback() {
    // 添加网络状态回调
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);
    // 添加用户加入会议回调
    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
    // 添加用户离开会议回调
    room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".promptMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".promptMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".promptMsg").html("网络故障,重新加会中...");
        /**
         * @desc 多次后重新加会超时后，开启持续永久重新加会
         */
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
    console.log("============onUserJoinNotify(),users:", users);
    participantsHandle(users);
}

/**
 * @desc 参会者退会回调
 */
function onUserLeaveNotify() {
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
    $('.remoteVideo_userName').html('');
    remote_video.className = '';
    remote_audio.className = '';
}

/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {
    participants.forEach(function (user) {
        // 添加摄像头状态变更回调
        user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
        // 添加麦克风状态变更回调
        user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);
        // 添加摄像头发布状态回调
        user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
        user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
        // 添加视频订阅和取消订阅结果回调
        user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
        user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);
        // 添加音频订阅和取消订阅结果回调
        user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
        user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);
    })
}

/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            local_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            local_audio.className = 'closeMicrophone';
        }
    } else {
        if (status == StreamStatus.published) {
            remote_audio.className = 'openMicrophone';
        } else if (status == StreamStatus.init) {
            remote_audio.className = 'closeMicrophone';
        }
    }
}

/**
 * 房间中发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
    video.unsubscrible();
}

/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
    if (userId == room.selfUser.id) {
        if (status == StreamStatus.published) {
            local_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            local_video.className = 'closeCamera';
        }
    } else {
        if (status == StreamStatus.published) {
            remote_video.className = 'openCamera';
        } else if (status == StreamStatus.init) {
            remote_video.className = 'closeCamera';
        }
    }
}

//订阅未订阅的视频
function onPublishCameraNotify(videos) {
    videos.forEach(function (video) {
        //只订阅未订阅过的视频
        var subVideoIdsLen = room.selfUser.subVideoIds.length;
        if (subVideoIdsLen > 0) {
            var isSub = false;
            for (var i = 0; i < subVideoIdsLen; i++) {
                var videoId = room.selfUser.subVideoIds[i];
                if (video.id == videoId) {
                    isSub = true;
                    break;
                }
            }
            if (!isSub) {
                video.subscrible();
            }
        } else {
            video.subscrible();
        }
    });
}

/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
    $('.remoteVideo_userName').html(userName);
    remote_video.className = 'openCamera';
    room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
    remote_audio.className = 'openMicrophone';
    room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
    
}

/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
    room.selfUser.attachAudioElementMediaStream(remoteAudio, null);
}

