//获取应用实例
const app = getApp();

Page({

  /**
   * 页面的初始数据
   */
  data: {
    rpcManager: null,
    seatAccount: "",
    acdLineLengthState: false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.registerClientCallback();
    this.data.rpcManager = app.data.avdSDK.client.getRpcManager();
  },

  /**
*注册Client级别回调
*/
  registerClientCallback: function () {
     app.data.avdSDK.client.addCallback(app.data.avdSDK.Enum.RpcManagerCallbackEnum.RPC_NOTIFICATION, this.onRpcNotification);
     app.data.avdSDK.client.addCallback(app.data.avdSDK.Enum.ClientCallbackEnum.MQTT_CONNECT_STATE, this.onMqttConnectState);
  },

  onRpcNotification: function (data) {
    console.log("+++onRpcNotification, data :", data);
  },

  onMqttConnectState: function (state){
    console.log("+++onMqttConnectState(),state:", state);
    if (state == app.data.avdSDK.Enum.mqttConnectStateEnum.connect){
      wx.hideLoading();
    } else if (state == app.data.avdSDK.Enum.mqttConnectStateEnum.reconnect){
       wx.showLoading({
        title: '重连中...',
        mask: true
      });
    }else{
      wx.hideLoading();
    }
  },
  

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },


  rpcNotifiButt: function () {
    var self = this;
    var jsonObj = {
      "jsonrpc": "2.0",
      "id": "505",
      "method": "acdSetClientOptions",
      "params": {
        "clientType": 2,
        "clientID": app.data.userInfo.userId,
        "username": app.data.userInfo.userName,
        "options": {
             "dataSource": "bj",
             "backInfo": "",
             "userinfo": "131563546",
         }
      }
    };
    var jsonStr = JSON.stringify(jsonObj);
    console.log(new Date(), "+++call.js,sendAcdSetClientOptions():====jsonStr:", jsonStr);

    self.data.rpcManager.notification(jsonObj).then(function () {
        console.log(new Date(), "+++rpc notification  acdSetClientOptions  success");
    }).catch(function (error) {
      self.setData({
          tipsMessage: "上报客户端信息时RPC通知(acdSetClientOptions)失败。" + error.message
      })
    })
  },



  rpcButt: function(){
    var self = this;

    var jsonObj = {
      "jsonrpc": "2.0",
      "id": "500",
      "method": "acdCall",
      "params": {
        "businessCode": app.data.userInfo.userId,
        "sortValue": app.data.userInfo.mobile
      }
    };

    self.data.rpcManager.call(jsonObj).then(function (data) {
        console.log("+++rpc acdCall成功, data :", data);
        self.setTipsMessage(data);
    }).catch(function (error) {
        console.log("+++RPC acdCall错误，error:", error);
    })
  },

  setTipsMessage: function (data) {
    var self = this;
    if (data.type == "availableSeat") { //返回可用坐席id
      var seatAccount = data.result.account;
      self.setData({
        seatAccount: seatAccount,
        acdLineLengthState: false,
      })
      self.toCall();
    } else if (data.type == "acdLineLength") { //返回排队人数
      var lineLength = data.result.lineLength;
      self.setData({
        tipsMessage: "当前排队人数" + lineLength + "人，请等待。",
        acdLineLengthState: true,
      })
    } else if (data.type == "invalidSeat") { //无可用坐席
      self.setData({
        tipsMessage: "无对应服务坐席，请核实。",
        acdLineLengthState: false,
      })
    }
  },

  rpcCancelButt:function(){
      var self = this;
      var jsonObj = {
        "jsonrpc": "2.0",
        "id": "505",
        "method": "acdCancelCall",
        "params": {
          "clientID": app.data.userInfo.userId,
          "mobile": app.data.userInfo.mobile
        }
      };
      self.data.rpcManager.notification(jsonObj).then(function () {
        console.log("+++rpc notification cancelCall success");
        var url = "../login/login";
        wx.reLaunch({
          url: url
        });

      }).catch(function (error) {
        console.log("+++取消呼叫RPC通知失败。" + error.message);
      })
    
  },

  back2acdgroup: function(){
    var url = "../acdgroup/acdgroup"
    wx.reLaunch({
      url: url
    });
  }

})