var JHEnum = require('../../jh/utils/enum.js');

//获取应用实例
const app = getApp();

const basePlayUser = {
  userId: '',
  userName: '',
  head: '',
  playUrlMain: '',
  playUrlAssist: '',
  playerUrlScreen: '',
  videoPlaying: false,
  audioPlaying: false,
  screenPlaying: false,
  isPub: false,
  isHandup: false,
  pubCameraId: ""
};

Page({

  /**
   * 页面的初始数据
   */
  data: {
    roomId: '',
    trumpet: true,

    pusher: {
      userId: '',
      userName: '',
      url: '', //推流地址。目前仅支持 flv, rtmp 格式
      muted: true, //是否静音
      enableCamera: false, //开启摄像头
      autoFocus: true, //自动聚集
      orientation: "vertical", //vertical，horizontal
      beauty: 6.3, //美颜
      whiteness: 0, //美白
      aspect: "9:16", //宽高比，可选值有 3:4, 9:16	
      minBitrate: 500, //最小码率
      maxBitrate: 1000, //最大码率
      waitingImage: '', //进入后台时推流的等待画面	
      waitingImageHash: '', //等待画面资源的MD5值	
      backgroundMute: false, //进入后台时是否静音

      pusherContext: '',
      classValue: 'large-live', //css
      frontCamera: true, //开启前置摄像头
      videoPlaying: false,
      audioPlaying: false,

      audioOpenState: false,
      videoOpenState: false,

      isControlCameraBtn: false,
      isControlMicrophoneBtn:false,

      subScribleTimer:null,
      majorScreenDisposeTimer:null
    },

    largePlayUser: basePlayUser,
    smallPlayUser: basePlayUser,

    players: [],
    userLists: [],
    playerLists: [],
    chatLists: [],

    galleryPlayers: [],

    galleryTableMaxVideoNum: 4, //画廊模式table显示的最大视频路数
    galleryBeginTableIndex: 3, //画廊模式对应的table 启始index （0：用户列表， 1：聊天， 2：演讲者模式，3及以后：画廊模式）
    baselineTableIndex: 2,  //切换参会者或者聊天table时，保存的上一个table，用户回退时应用
    currentTableIndex: 2,  //当前的table index （0：用户列表， 1：聊天， 2：演讲者模式，3及以后：画廊模式）

    currentPattern: JHEnum.patternType.lecturer, //  当前的模式状态 （0演讲者, 1画廊）
    largerScreenPatternType: JHEnum.LargerScreenPatternType.own, //大屏模式类型枚举

    isFullMute: false, //全员静音状态
    isForbiddenCamera: false, //全员禁止状态

    chatUnreadNum: 0, //未读聊天记录数
  },


  /**
   * 阻止滑动事件
   */
  catchTouchMove: function(res) {
    return false;
  },

  changeLivePlayerState: function () {
    app.data.lockingUserId = this.data.pusher.userId;
    this.setData({
      largerScreenPatternType: JHEnum.LargerScreenPatternType.locking
    })
    this.majorScreenDispose();
  },
  changeSmallPlayerState: function () {
    if (this.data.smallPlayUser.userId){
      app.data.lockingUserId = this.data.smallPlayUser.userId;
      this.setData({
        largerScreenPatternType: JHEnum.LargerScreenPatternType.locking
      })
    }
    this.majorScreenDispose();
  },
  /**
   * 改变当前模式
   */
  changeCurrentPattern: function() {
    console.log(new Date(),"++++++changeCurrentPattern++++++")
    if (this.data.currentPattern == JHEnum.patternType.lecturer) {
      this.setData({
        currentPattern: JHEnum.patternType.gallery,
      })
      this.changeToTable(this.data.galleryBeginTableIndex);
    } else {
      this.setData({
        currentPattern: JHEnum.patternType.lecturer
      })
      this.changeToTable(this.data.galleryBeginTableIndex - 1);
    }
    this.isSubscrible();
  },


  /**
   * 改变当前页
   */
  changeToTable(tableIndex) {
    console.log(new Date(),"++++++changeToTable++++++")
    if (tableIndex < this.data.galleryBeginTableIndex - 1 && this.data.currentTableIndex > this.data.galleryBeginTableIndex - 2) {
      var baselineTableIndex = this.data.currentTableIndex;
      this.setData({
        currentTableIndex: tableIndex,
        baselineTableIndex: baselineTableIndex
      })
    } else {
      this.setData({
        currentTableIndex: tableIndex
      })
    }

    if (this.data.currentTableIndex == 1){
       this.setData({
          chatUnreadNum: 0
       })
    }
  },


  backLastPage() {
    console.log(new Date(),"++++++backLastPage++++++")
    this.setData({
      currentTableIndex: this.data.baselineTableIndex
    })
  },


  changeAllVideoStatus(e) {
    console.log(new Date(),"++++++changeAllVideoStatus++++++")
    this.setData({
      isForbiddenCamera: e.detail
    })
  },


  changeAllAudioStatus(e) {
    console.log(new Date(),"++++++changeAllAudioStatus++++++")
    this.setData({
      isFullMute: e.detail
    })
  },


  /**
   * 画廊模式翻上一页
   */
  toLastPage: function() {
    console.log(new Date(),"++++++toLastPage++++++")
    var tableIndex = this.data.currentTableIndex - 1;
    if (tableIndex < this.data.galleryBeginTableIndex) {
      return;
    }
    this.changeToTable(tableIndex);
    this.isSubscrible();
  },


  /**
   * 画廊模式翻下一页
   */
  toNextPage: function() {
    console.log(new Date(),"++++++toNextPage++++++")
    var page = this.data.currentTableIndex + 1;
    if (page > this.data.galleryPlayers.length + this.data.galleryBeginTableIndex - 1) {
      return;
    }
    this.changeToTable(page);
    this.isSubscrible();
  },


  /**
   *改变大屏模式
   */
  updateLargerScreenPattern: function(largerScreenPatternType) {
    console.log(new Date(),"++++++updateLargerScreenPattern++++++")
    this.data.largerScreenPatternType = largerScreenPatternType;
  },


  /**
   *计算画廊模式用户列表
   */
  changeGalleryPlayers: function() {
    console.log(new Date(),"++++++changeGalleryPlayers++++++")
    var players = this.data.playerLists;
    var galleryTableMaxVideoNum = this.data.galleryTableMaxVideoNum;
    var galleryLength = Math.ceil(players.length / galleryTableMaxVideoNum);
    var galleryPlayers = [];
    for (var i = 0; i < galleryLength; i++) {
      galleryPlayers.push([]);
    }

    for (var k in players) {
      var index = parseInt(k / galleryTableMaxVideoNum);
      galleryPlayers[index].push(players[k])
    }
    this.setData({
      galleryPlayers: galleryPlayers
    });
  },

  getPlayerListsAndUserList() {
    console.log(new Date(),"+++++++++getPlayerListsAndUserList+++++++++");

    var players = this.data.players;
    var newPlayers = [];
    var playerLists = [];
    var pubUser = [];
    var unpubUser = [];

    var selfUser = [];
    var hostUser = [];
    var uphandUser = [];
    var other = [];
    var userLists = [];

    for (var k in players) {
      if (players[k].userId != app.data.userInfo.userId) {
        if (players[k].isPub) {
          pubUser.push(players[k]);
        } else {
          unpubUser.push(players[k]);
        }
      }else{
        newPlayers.push(players[k]);
      }


      if (players[k].userId == app.data.userInfo.userId) {
        selfUser.push(players[k]);
      } else if (players[k].userId == app.data.hostId) {
        hostUser.push(players[k]);
      } else if (players[k].isHandup) {
        uphandUser.push(players[k]);
      } else {
        other.push(players[k]);
      }
    }
    newPlayers = newPlayers.concat(pubUser).concat(unpubUser);
    playerLists = pubUser.concat(unpubUser);
    userLists = selfUser.concat(hostUser).concat(uphandUser).concat(other);

    var chatLists = [];

    for (var k in userLists) {
      if (k == 0) {
        chatLists.push({
          userId: "all",
          userName: "所有人"
        })
      } else {
        chatLists.push({
          userId: userLists[k].userId,
          userName: userLists[k].userName
        })
      }
    }

    this.setData({
      players: newPlayers,
      playerLists: playerLists,
      userLists: userLists,
      chatLists: chatLists
    })
    this.changeGalleryPlayers();
    this.isSubscrible();
  },



  /**
   *插入新增用户信息
   */
  insertPlayer: function(player) {
    console.log(new Date(),"++++++insertPlayer++++++")
    var players = this.data.players;
    players.push(player);
    this.setData({
      players: players
    });
    this.getPlayerListsAndUserList();

  },

  /**
   *获取用户信息
   */
  getPlayer: function(userId) {
    console.log(new Date(),"++++++getPlayer++++++");
    var player = null;
    for (var k in this.data.players) {
      if (this.data.players[k].userId == userId) {
        player = this.data.players[k];
        break;
      }
    }
    return player;
  },


  /**
   * 更新用户信息
   */
  updatePlayer: function(userId, newPlayer) {
    console.log(new Date(),"++++++updatePlayer++++++");
    var self = this;
    for (var k in self.data.players) {
      if (self.data.players[k].userId == userId) {
        self.data.players[k] = newPlayer;
        if (userId == self.data.largePlayUser.userId) {
          self.setData({
            largePlayUser: newPlayer
          });
        } else if (userId == self.data.smallPlayUser.userId) {
          self.setData({
            smallPlayUser: newPlayer
          });
        }
        self.getPlayerListsAndUserList();
        break;
      }
    }
  },

  /**
   * 删除用户信息
   */
  deletePlayer: function(userId) {
    console.log(new Date(),"++++++deletePlayer++++++");
    for (var k in this.data.players) {
      if (this.data.players[k].userId == userId) {
        if (userId == app.data.screenShareUserId) {
          app.data.screenShareUserId = ""
        } else if (userId == app.data.focusUserId) {
          app.data.focusUserId = ""
        } else if (userId == app.data.spokesmanUserId) {
          app.data.spokesmanUserId = ""
        } else if (userId == app.data.lockingUserId) {
          app.data.lockingUserId = ""
        }

        this.data.players.splice(k, 1);
        this.setData({
          players: this.data.players
        })
        this.getPlayerListsAndUserList();
        this.majorScreenDispose();
        break;
      }
    }
    if (this.data.currentTableIndex - this.data.galleryBeginTableIndex >= this.data.galleryPlayers.length) {
      this.toLastPage();
    } else if (this.data.lastPage - this.data.galleryBeginTableIndex >= this.data.galleryPlayers.length) {
      this.data.lastPage--;
    } else if (this.data.currentTableIndex == this.data.galleryBeginTableIndex && this.data.players.length < 2) {
      this.setData({
        currentTableIndex: this.data.galleryBeginTableIndex - 1
      })
    } else if (this.data.players.length < 2) {
      this.data.lastPage = this.data.galleryBeginTableIndex - 1;
    }
  },


  /**
   * 处理订阅和取消订阅逻辑
   */

  isSubscrible() {
    
    var self = this;
    clearTimeout(self.data.subScribleTimer);
    self.data.subScribleTimer = setTimeout(() => {
      console.log(new Date(),"++++++isSubscrible++++++");
      var currentTableIndex = self.data.currentTableIndex;
      var galleryTableMaxVideoNum = self.data.galleryTableMaxVideoNum; //画廊模式视频数
      var galleryBeginTableIndex = self.data.galleryBeginTableIndex; //画廊模式开始页数 （从第三页开始以后为画廊模式页面）
      var baselineTableIndex = self.data.baselineTableIndex; //切换参会者或者聊天页时，保存的上一个页面，用户回退
      var playerLists = self.data.playerLists;
      for (var k in playerLists) {
        var user = app.data.avdSDK.room.getUser(playerLists[k].userId);
        var video = user.getVideo(playerLists[k].pubCameraId);
        if (!user || !video || !playerLists[k].isPub) {
          continue
        }

        if (currentTableIndex < galleryBeginTableIndex - 1) {
          if (baselineTableIndex != galleryBeginTableIndex - 1) {
            var maxIndex = (baselineTableIndex - galleryBeginTableIndex + 1) * galleryTableMaxVideoNum;
            var minIndex = (baselineTableIndex - galleryBeginTableIndex) * galleryTableMaxVideoNum;

            if (k >= minIndex && k < maxIndex || playerLists[k].userId == self.data.largePlayUser.userId || playerLists[k].userId == self.data.smallPlayUser.userId) {
              if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) < 0) {
                console.log(new Date(),'--订阅视频通知Subscrible--' + user.name);
                video.subscrible().catch((error) => {
                  console.log(error);
                });
              }
            } else {
              if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) > -1) {
                console.log(new Date(),'--取消订阅视频通知unSubscrible--' + user.name);
                video.unsubscrible();
              }
            }

          }
        } else if (currentTableIndex == galleryBeginTableIndex - 1) {
          if (playerLists[k].userId == self.data.largePlayUser.userId || playerLists[k].userId == self.data.smallPlayUser.userId) {
            if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) < 0) {
              console.log(new Date(),'--订阅视频通知Subscrible--' + user.name);
              video.subscrible().catch((error) => {
                console.log(error);
              });
            }
          } else {
            if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) > -1) {
              console.log(new Date(),'--取消订阅视频通知unSubscrible--' + user.name);
              video.unsubscrible();
            }
          }
        } else {
          var maxIndex = (currentTableIndex - galleryBeginTableIndex + 1) * galleryTableMaxVideoNum;
          var minIndex = (currentTableIndex - galleryBeginTableIndex) * galleryTableMaxVideoNum;
          if (k >= minIndex && k < maxIndex || playerLists[k].userId == self.data.largePlayUser.userId || playerLists[k].userId == self.data.smallPlayUser.userId) {
            if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) < 0) {
              console.log(new Date(),'--订阅视频通知Subscrible--' + user.name);
              video.subscrible().catch((error) => {
                console.log(error);
              });
            }
          } else {
            if (app.data.avdSDK.room.selfUser.subVideoIds.indexOf(video.id) > -1) {
              console.log(new Date(),'--取消订阅视频通知unSubscrible--' + user.name);
              video.unsubscrible();
            }
          }
        }
      }
    }, 300)

  },


  /**
   * 扬声器状态改变
   */
  trumpetClick: function() {
    console.log(new Date(),"++++++trumpetClick++++++");
    var self = this;
    this.setData({
      trumpet: !self.data.trumpet
    });
  },


  /**
   * 切换前后置摄像头
   */
  switchCameraClick: function() {
    console.log(new Date(),"++++++switchCameraClick++++++");
    var self = this;
    self.data.pusher.frontCamera = !self.data.pusher.frontCamera;
    self.setData({
      pusher: self.data.pusher
    })
    self.data.pusher.pusherContext.switchCamera();
  },

  
  /**
   * 更多按钮点击
   */
  moreBtn: function() {
    console.log(new Date(),"++++++moreBtn++++++");
    var self = this;
    var handupName = "";
    var user = self.getPlayer(app.data.userInfo.userId);
    if (user.isHandup){
      handupName  = "放下手"
    }else{
      handupName = "举手"
    }
    if (app.data.avdSDK.room.selfUser.id == app.data.hostId){
      wx.showActionSheet({
        itemList: ['显示信息'],
        success: function (res) {
          if (res.tapIndex == 0) {
            
          }
        },
        fail: function (res) {
          console.log(res.errMsg)
        }
      })
    }else{
      wx.showActionSheet({
        itemList: ['显示信息', handupName],
        success: function (res) {
          if (res.tapIndex == 0) {

          } else if (res.tapIndex == 1) {
            
            self.setHandup();
          }
        },
        fail: function (res) {
          console.log(res.errMsg)
        }
      })
    }
    
  },

  /**
   * 离开会议按钮点击事件
   */
  leaveRoom: function() {
    console.log(new Date(),"++++++leaveRoom++++++");
    var self = this;
    if (app.data.avdSDK.room.selfUser.id != app.data.hostId) {
      wx.showModal({
        title: '提示',
        content: '确认离开会议？',
        success: function(res) {
          if (res.confirm) {
            console.log('用户点击确定');
            var reason = 1; //退会原因
            app.data.avdSDK.room.leave(reason).then(function() {
              wx.redirectTo({
                url: "../touch/touch",
              });
            });
          } else if (res.cancel) {

          }
        }
      })
    } else {
      wx.showActionSheet({
        itemList: ['离开会议', '结束会议'],
        success: function(res) {
          if (res.tapIndex == 0) {
            var reason = 1; //退会原因
            app.data.avdSDK.room.leave(reason).then(function() {
              wx.redirectTo({
                url: "../touch/touch",
              });
            });
          } else if (res.tapIndex == 1) {
            app.data.avdSDK.room.closeRoom(app.data.avdSDK.room.selfUser.id).then(function() {
              wx.redirectTo({
                url: "../touch/touch",
              });
            })
          }
        },
        fail: function(res) {
          console.log(res.errMsg)
        }
      })
    }


  },

  /**
   * 关闭会议事件
   */
  closeRoom: function() {
    console.log(new Date(),"++++++closeRoom++++++");
    wx.showModal({
      title: '提示',
      content: '确认关闭会议？',
      success: function(res) {
        if (res.confirm) {
          app.data.avdSDK.room.closeRoom(app.data.avdSDK.room.selfUser.id);
        } else if (res.cancel) {

        }
      }
    })
  },

  createPusherContext: function() {
    var self = this;
    if (!self.data.pusher.pusherContext) {
      self.data.pusher.pusherContext = wx.createLivePusherContext(self.data.pusher.userId + "_pusher");
    }
  },


  pusherStop: function() {
    var self = this;
    console.log(new Date(),"++++++pusherStop++++++");
    self.data.pusher.audioPlaying = false;
    self.data.pusher.vidioPlaying = false;
    self.setData({
      pusher: self.data.pusher
    });
    self.data.pusher.pusherContext.stop();
  },


  onPushEvent: function(e) {
    var self = this;
    return;
    self.createPusherContext();

    var code;
    if (e.detail) {
        code = e.detail.code;
    } else {
        code = e;
    }

    var errmessage = '';
    switch (code) {
      case 1002:
          break;

      case -1301:
          console.error('打开摄像头失败: ', code);
          break;

      case -1302:
          console.error('打开麦克风失败: ', code);
          break;

      case -1307:
          console.error('推流连接断开: ', code);

          // this.pusherStop();
          wx.showToast({
             title: '推流连接断开',
          })
          break;

      default:
          // console.log('推流情况：', code);

    }

  },

  onPushStatus: function(e) {
    // console.log("+++++++++=push status start++++++++++++++++++");
    // console.log("videoBitrate:", e.detail.info.videoBitrate, "kbps");
    // console.log("videoFPS:", e.detail.info.videoFPS, "帧");
    // console.log("resolution:", e.detail.info.videoWidth, "x", e.detail.info.videoHeight);

    // console.log("audioBitrate:", e.detail.info.audioBitrate, "kbps");
    // console.log("网络抖动情况:", e.detail.info.netJitter);
    // console.log("+++++++++=push status end++++++++++++++++++");
  },




  onPushError: function(e) {
    console.log('推流错误：', e);
    e.detail.errCode == 10001 ? (e.detail.errMsg = '未获取到摄像头功能权限，请删除小程序后重新打开') : '';
    e.detail.errCode == 10002 ? (e.detail.errMsg = '未获取到录音功能权限，请删除小程序后重新打开') : '';

    wx.showToast({
      title: e.detail.errMsg || '未获取到摄像头、录音功能权限，请删除小程序后重新打开',
    })

  },


  /**
   * 切换音频状态事件
   */
  muteClick: function() {
    var self = this;
    console.log(new Date(),"++++++muteClick++++++");
    if (self.data.isControlMicrophoneBtn){
      return;
    }
    self.data.isControlMicrophoneBtn = true;
    if (!self.data.pusher.muted) {
      app.data.avdSDK.room.selfUser.audio.unpublish().then(() => {
        self.data.pusher.muted = true;
        self.data.pusher.audioPlaying = false;
        self.setData({
          pusher: self.data.pusher
        });
        var user = self.getPlayer(app.data.avdSDK.room.selfUser.id);
        user.audioPlaying = false;
        self.updatePlayer(user.userId, user);
        wx.hideLoading();
        self.data.isControlMicrophoneBtn = false;
      }).catch((e) => {
        console.log(e);
        wx.hideLoading()
        self.data.isControlMicrophoneBtn = false;
        wx.showModal({
          title: '取消发布音频出错提示',
          content: e.error.message + "[" + e.error.code + "]",
          showCancel: false
        })

      });
    } else {
      if (app.data.hostId != app.data.avdSDK.room.selfUser.id && self.data.isFullMute) {
        wx.showModal({
          title: '提示',
          content: "主持人开启了全员禁用音频！",
          showCancel: false
        })
        self.data.isControlMicrophoneBtn = false;
        return;
      }
      wx.showLoading({
        title: '正在打开音频...',
        mask:true
      })
      
      app.data.avdSDK.room.selfUser.audio.publish().then(() => {
        self.data.pusher.muted = false;
        self.data.pusher.audioPlaying = true;
        self.data.pusher.url = app.data.avdSDK.room.selfUser.pusherUrl;
        self.setData({
          pusher: self.data.pusher
        });
        var user = self.getPlayer(app.data.avdSDK.room.selfUser.id);
        user.audioPlaying = true;
        self.updatePlayer(user.userId, user);
        wx.hideLoading()
        self.data.isControlMicrophoneBtn = false;
        if (!self.data.pusher.enableCamera) {
          self.data.pusher.pusherContext.stop();
          setTimeout(() => {
            self.data.pusher.pusherContext.start();
          }, 500)
        }
        console.log(new Date(),"发布音频成功:", self.data.pusher);
      }).catch((e) => {
        wx.hideLoading()
        self.data.isControlMicrophoneBtn = false;
        wx.showModal({
          title: '发布音频出错提示',
          content: e.error.message + "[" + e.error.code + "]",
          showCancel: false
        })
      });
    }
  },

  /**
   * 切换视频状态事件
   */
  enableCameraClick: function() {
    var self = this;
    console.log(new Date(),"++++++enableCameraClick++++++");
    if (self.data.isControlCameraBtn){
      return;
    }
    self.data.isControlCameraBtn = true;

    if (self.data.pusher.enableCamera) {
      app.data.avdSDK.room.selfUser.videos[0].unpublish().then(() => {
        self.data.pusher.enableCamera = false;
        self.data.pusher.videoPlaying = false;
        self.setData({
          pusher: self.data.pusher
        });
        var user = self.getPlayer(app.data.avdSDK.room.selfUser.id);
        user.videoPlaying = false;
        user.isPub = false;
        self.updatePlayer(user.userId, user);
        wx.hideLoading()
        self.data.isControlCameraBtn = false;

        if (self.data.pusher.audioPlaying) {
          self.data.pusher.pusherContext.stop();
          setTimeout(() => {
            self.data.pusher.pusherContext.start();
          }, 500)
        }

      }).catch((e) => {
        console.log(e);
        wx.hideLoading()
        self.data.isControlCameraBtn = false;
        wx.showModal({
          title: '取消发布视频出错提示',
          content: e.error.message + "[" + e.error.code + "]",
          showCancel: false
        })

      });
    } else {
      if (app.data.hostId != app.data.avdSDK.room.selfUser.id && self.data.isForbiddenCamera) {
        wx.showModal({
          title: '提示',
          content: "主持人开启了全员禁用视频！",
          showCancel: false
        })
        self.data.isControlCameraBtn = false;
        return;
      }
      wx.showLoading({
        title: '正在打开摄像头...',
        mask: true
      })
      app.data.avdSDK.room.selfUser.videos[0].publish().then(() => {
        self.data.pusher.enableCamera = true;
        self.data.pusher.videoPlaying = true;
        self.data.pusher.url = app.data.avdSDK.room.selfUser.pusherUrl;
        self.setData({
          pusher: self.data.pusher
        });
        var user = self.getPlayer(app.data.avdSDK.room.selfUser.id);
        user.videoPlaying = true;
        user.isPub = true;
        self.updatePlayer(user.userId, user);
        wx.hideLoading()
        self.data.isControlCameraBtn = false;

        self.data.pusher.pusherContext.stop();
        setTimeout(() => {
          self.data.pusher.pusherContext.start();
        }, 500)
        console.log(new Date(),"发布视频成功:", self.data.pusher);
      }).catch((e) => {
        console.log(new Date(),"发布视频出错提示:", e);
        wx.hideLoading();
        self.data.isControlCameraBtn = false;
        wx.showModal({
          title: '发布视频出错提示',
          content: e.error.message + "[" + e.error.code + "]",
          showCancel: false
        })
      });
    }
  },


  onPlayEvent: function(e) {
    // if (e.detail.code == -2301 ){
    //   console.log('拉流情况：', e.detail.code + "," + e.detail.message);
    // }else{
    //   console.error('拉流情况失败:', e.detail.code + "," + e.detail.message);
    // }
  },

  onPlayStatus: function(e) {
    console.log(new Date(),"+++++++++=play status start++++++++++++++++++");
    console.log(new Date(),"videoBitrate:", e.detail.info.videoBitrate, "kbps");
    // console.log("videoFPS:", e.detail.info.videoFPS, "帧");
    // console.log("resolution:", e.detail.info.videoWidth, "x", e.detail.info.videoHeight);

    // console.log("audioBitrate:", e.detail.info.audioBitrate, "kbps");
    // console.log("网络抖动情况:", e.detail.info.netJitter);
    // console.log("+++++++++=play status end++++++++++++++++++");
  },



  /**
   * 用户列表点击事件
   */
  userListClick: function() {
    console.log(new Date(),"++++++userListClick++++++");
    this.changeToTable(JHEnum.pageType.userList);
  },

  /**
   * 用户聊天点击事件
   */
  toChat: function(e) {
    console.log(new Date(),"++++++toChat++++++");
    if (e.detail) {
      this.chat.changeIndex(e.detail);
    }
    this.changeToTable(JHEnum.pageType.chat);
  },

  //设置举手及手放下
  setHandup() {
    console.log(new Date(),"++++++setHandup++++++");
    var user = this.getPlayer(app.data.userInfo.userId);
    if (user.isHandup) { //手放下操作
      var str = JSON.stringify({});
      app.data.avdSDK.room.selfUser.updateUserData(str);
      user.isHandup = false;
      this.updatePlayer(app.data.userInfo.userId, user);
    } else {
      var str = JSON.stringify({
        handup: true
      });
      app.data.avdSDK.room.selfUser.updateUserData(str);
      user.isHandup = true;
      this.updatePlayer(app.data.userInfo.userId, user);
    }
  },

  //放下指定参会者手
  handDown(e) {
    console.log(new Date(),"++++++handDown++++++");
    var userId = e.detail;
    var obj = {
       cmd: 100,
       fromUserId: app.data.userInfo.userId,
       content: {
          userId: userId
       }
    };
    var str = JSON.stringify(obj);
    console.log('++++', str);
    var dataArrayBuffer = app.data.avdSDK.Util.commonUtil.String2ArrayBufferMini(str);
    app.data.avdSDK.room.sendPrivateData(dataArrayBuffer, userId);
  },

  
  //放下所有手
  setAllHandDown() {
    console.log(new Date(),"++++++setAllHandDown++++++");
    var obj = {
        cmd: 101,
        fromUserId: app.data.userInfo.userId,
        content: {}
    };
    var str = JSON.stringify(obj);
    var dataArrayBuffer = app.data.avdSDK.Util.commonUtil.String2ArrayBufferMini(str);
    app.data.avdSDK.room.sendPublicData(dataArrayBuffer);
  },


  /**
   * @desc 把sdk callback回来的内容通知到page去做页面修改
   * @param {string} notifyType － 通知类型
   * @param {Object} params － 参数数组
   */
  sendPagesNotify: function(notifyType, params) {
    console.log(new Date(),"++++++sendPagesNotify++++++");
    if (this.userList) {
      this.userList.onPagesNotify(notifyType, params);
    }
  },


  registerRoomCallback: function() {
    console.log(new Date(),"registerRoomCallback");
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.connection_status, this.onConnectionStatus);

    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_join_notify, this.onUserJoinNotify);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_leave_notify, this.onUserLeaveNotify);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.leave_indication, this.onLeaveIndication);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.close_room_result, this.onCloseRoomResult);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.close_room_notify, this.onCloseRoomNotify);

    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.app_data_notify, this.onAppdataNotify);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_data_notify, this.onUserDataNotify);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.user_name_notify, this.onUserNameNotify);

    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.public_message, this.onPublicMessage);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.private_message, this.onPrivateMessage);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.public_data, this.onPublicData);
    app.data.avdSDK.room.addCallback(app.data.avdSDK.Enum.RoomCallback.private_data, this.onPrivateData);


    app.data.avdSDK.room.setRoomCallbackMonitorState2True();
  },


  startFun : function(){
    if (this.data.pusher.pusherContext && this.data.pusher.url) {
      this.data.pusher.pusherContext.start();
    }
    if (this.data.largePlayUser.userId) {
      wx.createLivePlayerContext("largePlay").play();
    }
    if (this.data.smallPlayUser.userId) {
      wx.createLivePlayerContext("smallPlay").play();
    }
    if (this.data.galleryPlayers.length > 0) {
    
      for (var k in this.data.galleryPlayers) {
        console.log(wx.createLivePlayerContext(k + "_galleryPlay"));
        for (var j in this.data.galleryPlayers[k]){
          wx.createLivePlayerContext(k + "_" + j + "_galleryPlay").play();
        }
      }
    }
  },
  onConnectionStatus: function(status) {
    console.log(new Date(),"----------onConnectionStatus----------")
    if (status == app.data.avdSDK.Enum.ConnectionStatus.connecting) {
      wx.showLoading({
        title: '重连中...',
        mask: true
      })
    } else if (status == app.data.avdSDK.Enum.ConnectionStatus.connected || status == app.data.avdSDK.Enum.ConnectionStatus.reconnected) {
      this.startFun();
      wx.hideLoading()
    } else if (status == app.data.avdSDK.Enum.ConnectionStatus.connectFailed) {
      wx.showLoading({
        title: '重新加会中...',
        mask: true
      })
    } else if (status == app.data.avdSDK.Enum.ConnectionStatus.reJoinConnected) {
      this.startFun();
      wx.hideLoading()
    } else if (status == app.data.avdSDK.Enum.ConnectionStatus.reJoinRoomTimeOut) {

      wx.showModal({
        title: '重新加会失败',
        showCancel: false,
        success: function (res) {
          if (res.confirm) {
            var reason = 1; //退会原因
            app.data.avdSDK.room.leave(reason).then(function () {
              wx.redirectTo({
                url: "../touch/touch",
              });
            });
          } else if (res.cancel) {

          }
        }
      })
    }
  },
  /**
   * @desc 参会者加会回调
   * @param {Object} users － 参会者数组
   */
  onUserJoinNotify: function(users) {
    console.log(new Date(),"++++++=onUserJoinNotify+++++++++");

    var self = this;

    
    this.participantsHandle(users);
    
  },


  /**
   * @desc 参会者退会回调
   * @param {int} opt - 退会类型
   * @param {int} reason  - 退会原因
   * @param {Object} user - 退会用户
   */
  onUserLeaveNotify: function(opt, reason, user) {
    console.log(new Date(),"++++++=onUserLeaveNotify+++++++++");
    this.deletePlayer(user.id);
  },



  /**
   * @desc 被踢出会议室
   * @param {Object} reason - 被踢原因
   * @param {Object} userId - 踢人的操作者
   */
  onLeaveIndication: function(reason, userId) {
    console.log(new Date(),"++++++=onLeaveIndication+++++++++");

    var user = getApp().data.avdSDK.room.getUser(userId);
    var userName = '';
    if (user != null) {
      userName = user.name;
    }

    if (reason == 804) { //同一个userid加会， 把前一个人踢下线
      wx.showModal({
        title: '退会提示',
        content: '您已在另一终端登陆，被踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else if (reason == 808) { //调用rest api接口把人踢下线
      wx.showModal({
        title: '退会提示',
        content: '您被' + userName + '踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else if (reason == 809) { //无授权 15分钟以后强制踢人
      wx.showModal({
        title: '退会提示',
        content: '无授权，试用时限到期，您被' + userName + '踢出会议室。被踢原因：' + reason,
        showCancel: false
      });

    } else {
      wx.showModal({
        title: '退会提示',
        content: '您已被主持人从会议中踢出',
        showCancel: false
      });
    }

    setTimeout(function() {
      getApp().data.avdSDK.room.socketManager.close();
      wx.redirectTo({
        url: "../touch/touch",
      });
      return false;
    }, 5000);

  },


  /**
   * @desc 关闭会议回调结果
   * @param {int} result - 关闭结果
   * @param {String} description - 描述
   */
  onCloseRoomResult: function(result, description) {
    console.log(new Date(),"++++++=onCloseRoomResult+++++++++");

    if (result == 0) {
      wx.redirectTo({
        url: "../touch/touch",
      });
      return false;
    } else {
      wx.showModal({
        title: '关闭会议提示',
        content: '关闭会议异常。原因：' + description + '[' + result + ']',
        showCancel: false
      });
    }
  },


  /**
   * @desc 收到主持人关闭房间通知，退出会议操作
   * @param {int} roomId - 房间ID
   * @param {int} reason  -关闭会议原因
   */
  onCloseRoomNotify: function(roomId, reason) {
    console.log(new Date(),"++++++=onCloseRoomNotify+++++++++");
    if (reason == 810) {
      wx.showModal({
        title: '关闭会议提示',
        content: '主持人已关闭会议。',
        showCancel: false
      });

      setTimeout(function() {
        var reason = 1; //退会原因
        app.data.avdSDK.room.leave(reason).then(function() {
          wx.redirectTo({
            url: "../touch/touch",
          });
          return false;
        });
      }, 2000);

    }
  },


  /**
   * 房间应用扩展字段回调
   * @param {object} key － key值
   * @param {Object} value － value值
   */
  onAppdataNotify: function(key, value) {
    console.log(new Date(),"++++++++++++==onAppdataNotify+++++++++=");
    var self = this;

    if (key == JHEnum.appDataMeeting.host) {
      if (app.data.hostId != value) {
        app.data.hostId = value;
        var params = {
          id: value
        };
        if (app.data.hostId == app.data.avdSDK.room.selfUser.id){
          var user = self.getPlayer(app.data.avdSDK.room.selfUser.id);
          if (user.isHandup) {
            self.setHandup();
          }
        }
        self.sendPagesNotify("onHostIdChange", params);
      }

    } else if (key == JHEnum.appDataMeeting.focusVideo) {
      app.data.focusUserId = value;
      self.majorScreenDispose();
      self.isSubscrible();
    } else if (key == JHEnum.appDataMeeting.muteAudioAll) {
      console.log(new Date(),"+++onAppdataNotify(),当前是否为全体静音模式:+++" + value);

      if (value == 'true') {
        self.setData({
          isFullMute: true
        })
        wx.showModal({
          title: '提示',
          content: "主持人开启了全员静音",
          showCancel: false
        })
        if (!self.data.pusher.muted) {
          app.data.avdSDK.room.selfUser.audio.unpublish().then(() => {
            this.data.pusher.muted = true;
            this.data.pusher.audioPlaying = false;
            this.setData({
              pusher: this.data.pusher
            });
            var user = this.getPlayer(app.data.avdSDK.room.selfUser.id);
            user.audioPlaying = false;
            this.updatePlayer(user.userId, user);
          }).catch((e) => {
            console.log(e);
            wx.showModal({
              title: '取消发布音频出错提示',
              content: e.error.message + "[" + e.error.code + "]",
              showCancel: false
            })
          });
        }
      } else {
        self.setData({
          isFullMute: false
        })
      }

    } else if (key == JHEnum.appDataMeeting.forbiddenCameraAll) {
      console.log(new Date(),"+++onAppdataNotify(),当前是否为全体禁用视频模式:+++" + value);

      if (value == 'true') {
        self.setData({
          isForbiddenCamera: true
        })
        wx.showModal({
          title: '提示',
          content: "主持人开启了全员禁用视频",
          showCancel: false
        })
        if (self.data.pusher.enableCamera) {
          app.data.avdSDK.room.selfUser.videos[0].unpublish().then(() => {
            self.data.pusher.enableCamera = false;
            self.data.pusher.videoPlaying = false;
            self.setData({
              pusher: self.data.pusher
            });
            var user = this.getPlayer(app.data.avdSDK.room.selfUser.id);
            user.videoPlaying = false;
            user.isPub = false;
            this.updatePlayer(user.userId, user);
          }).catch((e) => {
            console.log(e);
            wx.showModal({
              title: '取消发布视频出错提示',
              content: e.error.message + "[" + e.error.code + "]",
              showCancel: false
            })
          });
        }
      } else {
        self.setData({
          isForbiddenCamera: false
        })
      }
    } else if (key == JHEnum.appDataMeeting.lecturer) {
      app.data.spokesmanUserId = value;
      self.majorScreenDispose();
      self.isSubscrible();
    } else if (key == JHEnum.appDataMeeting.interact) {

    } else if (key == JHEnum.appDataMeeting.controller) {

    }
  },

  /**
   * 用户扩展内容更新回调
   * @param {String} userData - 用户扩展内容
   * @param {String} userId - 用户id
   */
  onUserDataNotify: function(userData, userId) {
    console.log(new Date(),"++++++=onUserDataNotify++++++=", userData, userId);
    var self = this;
    var isHandup = false;

    if (userData) {
      var dataObj = JSON.parse(userData);
      if (dataObj && dataObj.handup && dataObj.handup == true) {
        isHandup = true;
      }
    }
    var user = this.getPlayer(userId);
    user.isHandup = isHandup;
    self.updatePlayer(userId, user);
  },


  /**
   * 用户修改名字回调
   * @param {String} userName - 用户新名字
   * @param {String} userId - 用户id
   */
  onUserNameNotify: function(userName, userId) {
    console.log(new Date(),"++++++++++++==onUserNameNotify+++++++++=");
    if (this.data.pusher.userId == userId) {
      this.data.pusher.userName = userName;
      this.setData({
        pusher: this.data.pusher
      })
      var user = this.getPlayer(userId);
      user.userName = userName;
      user.head = userName.charAt(0);
      this.updatePlayer(userId, user);
    } else {
      var user = this.getPlayer(userId);
      user.userName = userName;
      user.head = userName.charAt(0);
      this.updatePlayer(userId, user);
    }

  },


  /**
   * 公聊回调
   * @param {Object} Message
   */
  onPublicMessage: function(Message) {
    console.log(new Date(),"++++++++++++==onPublicMessage+++++++++=");
    this.chat.fillMessageElement(Message, true);
    this.setData({
      chatUnreadNum: this.data.chatUnreadNum + 1
    })
  },

  /**
   * 私聊回调
   * @param {Object} Message
   */
  onPrivateMessage: function(Message) {
    console.log(new Date(),"++++++++++++==onPrivateMessage+++++++++=");
    this.chat.fillMessageElement(Message, false);
    this.setData({
      chatUnreadNum: this.data.chatUnreadNum + 1
    })
  },

  /**
   * 公有透明通道回调
   * @param {Object} jsonStr － json对象字符串
   * @param {String} userId － user id
   */
  onPublicData: function (jsonStr, userId) {
    var obj = JSON.parse(jsonStr);
    var self = this;

    if (obj && obj.cmd) {
      var cmd = obj.cmd;
      if (cmd == 101) {
        var user = self.getPlayer(app.data.userInfo.userId);
        if (user.isHandup) {
          self.setHandup();
        }
      }
    }
  },


  /**
   * 私有透明通道回调
   * @param {Object} jsonStr － json对象字符串
   * @param {String} userId － user id
   */
  onPrivateData(jsonStr, userId) {
    var obj = JSON.parse(jsonStr);
    var self = this;

    if (obj && obj.cmd) {
      var cmd = obj.cmd;
      if (cmd == 100 && obj.content && obj.content.userId == app.data.userInfo.userId) {
        var user = self.getPlayer(app.data.userInfo.userId);
        if (user.isHandup) {
          self.setHandup();
        }
      }
    }
  },




  participantsHandle: function(participants) {
    console.log(new Date(),"++++++++++++==participantsHandle+++++++++=");
    var self = this;
    participants.forEach(function(user) {
      user.addCallback(app.data.avdSDK.Enum.UserCallback.microphone_status_notify, self.onMicrophoneStatusNotify);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.camera_status_notify, self.onCameraStatusNotify);
      // user.addCallback(app.data.avdSDK.Enum.UserCallback.screen_status_notify, self.onScreenStatusNotify);


      user.addCallback(app.data.avdSDK.Enum.UserCallback.publish_camera_notify, self.onPublishCameraNotify);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.unpublish_camera_notify, self.onUnpublishCameraNotify);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.subscrible_camera_result, self.onSubscribleCameraResult);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.unsubscrible_camera_result, self.onUnsubscribleCameraResult);

      user.addCallback(app.data.avdSDK.Enum.UserCallback.subscrible_microphone_result, self.onSubscribleMicrophoneResult);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.unsubscrible_microphone_result, self.onUnsubscribleMicrophoneResult);

      user.addCallback(app.data.avdSDK.Enum.UserCallback.publish_screen_notify, self.onPublishScreenNotify);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.unpublish_screen_notify, self.onUnpublishScreenNotify);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.subscrible_screen_result, self.onSubscribleScreenResult);
      user.addCallback(app.data.avdSDK.Enum.UserCallback.unsubscrible_screen_result, self.onUnsubscribleScreenResult);


      if (user.id != app.data.avdSDK.room.selfUser.id) {
        var isHandup = false;
        if (user.data) {
          try {
            var dataObj = JSON.parse(user.data);
            if (dataObj.handup && dataObj.handup == true) {
              isHandup = true;
            }
          } catch (e) {
            //TODO handle the exception
            console.log("++++userId:" + user.userId + "  userName:" + user.userName + "的user.data 非规则json结构");
          }

        }
        var player = {
          userId: user.id,
          userName: user.name,
          head: user.name.charAt(0),
          playUrlMain: '',
          playUrlAssist: '',
          playerUrlScreen:'',
          videoPlaying: false,
          audioPlaying: false,
          screenPlaying: false,
          isPub: false,
          isHandup: isHandup,
          pubCameraId: ''
        }
        
        if (!self.getPlayer(player.userId)){
          self.insertPlayer(player);
        }
      }
      self.majorScreenDispose();
    });

    app.data.avdSDK.room.setUserCallbackMonitorState2True();
  },



  /**
   * 麦克风状态更新
   * @param {Object} status － 状态
   * @param {Object} microphoneId － 麦克风设备Id 
   * @param {Object} microphoneName － 麦克风设备名称
   * @param {Object} userId － 麦克风设备所属者ＩＤ
   */
  onMicrophoneStatusNotify: function(status, microphoneId, microphoneName, userId) {
    console.log(new Date(),"++++++=onMicrophoneStatusNotify+++++++++");

    // var params = {
    //   status: status,
    //   microphoneId: microphoneId,
    //   microphoneName: microphoneName,
    //   userId: userId
    // };
    // this.sendPagesNotify("onMicrophoneStatusNotify", params);
  },

  /**
   * 摄像头状态更新
   * @param {Object} status － 状态
   * @param {Object} cameraId － 摄像头设备Id
   * @param {Object} cameraName－ 摄像头设备名称
   * @param {Object} userId－ 摄像头设备所属者ＩＤ
   */
  onCameraStatusNotify: function(status, cameraId, cameraName, userId) {
    console.log(new Date(),"++++++=onCameraStatusNotify+++++++++");
    // var params = {
    //   tag: 'onCameraStatusNotify',
    //   status: status,
    //   cameraId: cameraId,
    //   cameraName: cameraName,
    //   userId: userId
    // };

    // this.sendPagesNotify("onCameraStatusNotify", params);

  },


  onPublishCameraNotify: function(videos) {
    console.log(new Date(),"++++++=onPublishCameraNotify+++++++++");
    var self = this;
    console.log(new Date(),"+++++++++++++++++++videos:", videos);
    videos.forEach(function(video) {
     

      //只订阅未订阅过的视频
      var subVideoIdsLen = getApp().data.avdSDK.room.selfUser.subVideoIds.length;
      if (subVideoIdsLen > 0) {
        var isSub = false;
        for (var i = 0; i < subVideoIdsLen; i++) {
          var videoId = getApp().data.avdSDK.room.selfUser.subVideoIds[i];
          if (video.id == videoId) {
            isSub = true;
            break;
          }
        }
        if (!isSub) {
          var player = self.getPlayer(video.ownerId);
          player.isPub = true;
          console.log(new Date(),"++++++++++++isSub=false,video.playerUrl:", video.playerUrl);
          player.playUrlMain = video.playerUrl;

          player.pubCameraId = video.id;
          self.updatePlayer(video.ownerId, player);
        }
      } else {
        var player = self.getPlayer(video.ownerId);
        player.isPub = true;
        console.log(new Date(),"++++++++++++isSub=true,video.playerUrl:", video.playerUrl);
        player.playUrlMain = video.playerUrl;

        player.pubCameraId = video.id;
        self.updatePlayer(video.ownerId, player);
      }
    });

  },


  onUnpublishCameraNotify: function(video) {
    console.log(new Date(),"++++++=onUnpublishCameraNotify+++++++++");
    var self = this;
    var player = self.getPlayer(video.ownerId);

    player.isPub = false;
    video.unsubscrible();
    self.updatePlayer(video.ownerId, player);

  },


  /**
   * 订阅远端视频流反馈
   * @param {Object} userId － 所属用户ＩＤ
   * @param {Object} userName－ 所属用户名称
   * @param {Object} cameraId－ 摄像头设备ＩＤ
   */
  onSubscribleCameraResult: function(userId, userName, cameraId) {
    console.log(new Date(),"++++++=onSubscribleCameraResult+++++++++");
    var self = this;
    var player = self.getPlayer(userId);

    player.videoPlaying = true;
    self.updatePlayer(userId, player);
  },



  /**
   * 取消订阅远端视频流反馈
   * @param {Object} userId－ 所属用户ＩＤ
   * @param {Object} userName－所属用户名称
   * @param {Object} cameraId－摄像头设备ＩＤ
   */
  onUnsubscribleCameraResult: function(userId, userName, cameraId) {
    console.log(new Date(),"++++++=onUnsubscribleCameraResult+++++++++");
    var self = this;
    var player = self.getPlayer(userId);

    player.videoPlaying = false;
    self.updatePlayer(userId, player);
  },


  /**
   * 订阅远端音频流反馈
   * @param {Object} stream－ 远端音频流
   * @param {Object} userId－ 所属用户ＩＤ
   * @param {Object} userName－所属用户名称
   */
  onSubscribleMicrophoneResult: function(userId, userName, microphoneId) {
    console.log(new Date(),"++++++=onSubscribleMicrophoneResult+++++++++");

    var self = this;
    var player = self.getPlayer(userId);
    var user = getApp().data.avdSDK.room.getUser(userId);
    player.playUrlAssist = user.audio.playerUrl;

    console.log(new Date(),"++++++++++++ser.audio.playerUrl:", user.audio.playerUrl);

    player.audioPlaying = true;
    self.updatePlayer(userId, player);
  },


  /**
   * 取消订阅远端音频流反馈
   * @param {Object} userId－ 所属用户ＩＤ
   * @param {Object} userName－所属用户名称
   */
  onUnsubscribleMicrophoneResult: function(userId, userName, microphoneId) {
    console.log(new Date(),"++++++=onUnsubscribleMicrophoneResult+++++++++");
    var self = this;
    var player = self.getPlayer(userId);

    player.audioPlaying = false;
    self.updatePlayer(userId, player);
  },


  onPublishScreenNotify: function(screens) {
    console.log(new Date(),"++++++=onPublishScreenNotify+++++++++");

    screens.forEach(function(screen) {
      //只订阅未订阅过的桌面共享
      var subScreenIdsLen = getApp().data.avdSDK.room.selfUser.subScreenIds.length;
      if (subScreenIdsLen > 0) {
        for (var i = 0; i < subScreenIdsLen; i++) {
          var screenId = room.selfUser.subScreenIds[i];
          if (screen.id == screenId) {
            isSub = true;
            break;
          }
        }
        if (!isSub) {
          screen.subscrible().catch((error) => {
            console.log(error);
          });
        }
      } else {
        screen.subscrible().catch((error) => {
          console.log(error);
        });
      }
    });

  },

  onUnpublishScreenNotify: function(screen) {
    console.log(new Date(),"++++++=onUnpublishScreenNotify+++++++++");
    screen.unsubscrible();
  },


  onSubscribleScreenResult: function(userId, userName, screenId) {
    console.log(new Date(),"++++++=onSubscribleScreenResult+++++++++");

    app.data.screenShareUserId = userId;
    var player = this.getPlayer(userId);
    player.playerUrlScreen = getApp().data.avdSDK.room.getUser(userId).screen.playerUrl;
    player.screenPlaying = true;
    this.updatePlayer(userId, player);
  },

  onUnsubscribleScreenResult: function(userId, userName, screenId) {
    console.log(new Date(),"++++++=onUnsubscribleScreenResult+++++++++");

    app.data.screenShareUserId = '';
    var player = this.getPlayer(userId);
    player.screenPlaying = false;
    this.updatePlayer(userId, player);
  },

  //主屏的界面显示逻辑处理
  majorScreenDispose: function() {
    var self = this;
    clearTimeout(self.data.majorScreenDisposeTimer);
    self.data.majorScreenDisposeTimer = setTimeout(()=>{
      if (app.data.screenShareUserId) {
        self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.desktopSharing);
        self.setLargePlayUser(app.data.screenShareUserId);
        if (app.data.focusUserId) {
          self.setSmallPlayUser(app.data.focusUserId);
        } else if (app.data.lockingUserId) {
          self.setSmallPlayUser(app.data.lockingUserId);
        } else if (app.data.spokesmanUserId) {
          self.setSmallPlayUser(app.data.spokesmanUserId);
        } else {
          self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
        }

      } else if (app.data.focusUserId) {
        self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.focus);
        self.setLargePlayUser(app.data.focusUserId);
        if (app.data.focusUserId == app.data.avdSDK.room.selfUser.id) {
          if (self.data.playerLists.length > 0) {
            self.setSmallPlayUser(self.data.playerLists[0].userId);
          }
        } else {
          self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
        }
      } else if (app.data.lockingUserId) {
        self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.locking);
        self.setLargePlayUser(app.data.lockingUserId);
        if (app.data.lockingUserId == app.data.avdSDK.room.selfUser.id) {
          if (self.data.playerLists.length > 0) {
            self.setSmallPlayUser(self.data.playerLists[0].userId);
          }

        } else {
          self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
        }
      } else {
        if (self.data.playerLists.length == 0) {
          self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.own);
          self.setLargePlayUser(app.data.avdSDK.room.selfUser.id);
          self.setSmallPlayUser();
        } else if (self.data.playerLists.length == 1) {
          self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.other);
          self.setLargePlayUser(self.data.playerLists[0].userId);
          self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
        } else {
          self.updateLargerScreenPattern(JHEnum.LargerScreenPatternType.spokesman);
          if (app.data.spokesmanUserId) {
            self.setLargePlayUser(app.data.spokesmanUserId);
            if (app.data.spokesmanUserId == app.data.avdSDK.room.selfUser.id) {
              self.setSmallPlayUser(self.data.playerLists[0].userId);
            } else {
              self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
            }
          } else {
            self.setLargePlayUser(self.data.playerLists[0].userId);
            self.setSmallPlayUser(app.data.avdSDK.room.selfUser.id);
          }
        }
      }
    },300)
    
  },
  /**
   * 设置大视频逻辑
   */
  setLargePlayUser: function(userId) {
    var self = this;
    console.log(new Date(),"setLargePlayUser");
    if (userId) {
      if (userId == app.data.avdSDK.room.selfUser.id) {
        self.data.pusher.classValue = "large-live";
        self.setData({
          pusher: self.data.pusher,
          largePlayUser: basePlayUser
        });
      } else {
        var user = self.getPlayer(userId);
        self.data.pusher.classValue = "small-live";
        if (user) {
          self.setData({
            pusher: self.data.pusher,
            largePlayUser: user
          });
        } else {
          self.setData({
            pusher: self.data.pusher,
            largePlayUser: basePlayUser
          });
        }

      }
    } else {
      self.setData({
        largePlayUser: basePlayUser
      });
    }

  },

  /**
   * 设置小视频逻辑
   */
  setSmallPlayUser: function(userId) {
    var self = this;
    console.log(new Date(),"setSmallPlayUser");
    if (userId) {
      if (userId == app.data.avdSDK.room.selfUser.id) {
        self.data.pusher.classValue = "small-live";
        self.setData({
          pusher: self.data.pusher,
          smallPlayUser: basePlayUser
        });
      } else {
        var user = self.getPlayer(userId);
        self.data.pusher.classValue = "large-live";
        if (user) {
          self.setData({
            pusher: self.data.pusher,
            smallPlayUser: user
          });
        } else {
          self.setData({
            pusher: self.data.pusher,
            smallPlayUser: basePlayUser
          });
        }
      }
    } else {
      self.setData({
        smallPlayUser: basePlayUser
      });
    }
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    this.participantsHandle(app.data.avdSDK.room.getParticipants());
    this.registerRoomCallback();

    this.data.pusher.userId = app.data.avdSDK.room.selfUser.id;
    this.data.pusher.userName = app.data.avdSDK.room.selfUser.name;

    this.data.pusher.url = '';

    this.data.pusher.minBitrate = app.data.avdSDK.room.selfUser.pusherMinBitrate;
    this.data.pusher.maxBitrate = app.data.avdSDK.room.selfUser.pusherMaxBitrate;

    this.data.audioOpenState = options.audioOpenState == 'true' ? true : false;
    this.data.videoOpenState = options.videoOpenState == 'true' ? true : false;

    this.setData({
      roomId: app.data.avdSDK.room.id,
      pusher: this.data.pusher
    });
    this.insertPlayer({
      userId: app.data.avdSDK.room.selfUser.id,
      userName: app.data.avdSDK.room.selfUser.name,
      head: app.data.avdSDK.room.selfUser.name.charAt(0),
      playUrlMain: '',
      playUrlAssist: '',
      playerUrlScreen: '',
      videoPlaying: false,
      audioPlaying: false,
      screenPlaying: false,
      isPub: false,
      isHandup: false,
      pubCameraId: ''
    });

  },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {
    var self = this;
    self.createPusherContext();
    self.userList = self.selectComponent("#userList");
    self.chat = self.selectComponent("#chat");

    if (self.data.videoOpenState && !self.data.isForbiddenCamera) {
      self.enableCameraClick();
    }

    if (self.data.audioOpenState && !self.data.isForbiddenCamera) {
      self.muteClick();
    }

    //保持屏幕常亮，做到手机不锁屏
    wx.setKeepScreenOn({
      keepScreenOn: true
    })

    self = this;
  },



  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {
  },


  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {
    console.log(new Date(),"++++++==onUnload++++++++++++=");
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function() {

  }
})