var JHEnum = require('../../utils/enum.js');
var api = require('../../restApi/api.js');
var config = require('../../config.js');
//获取应用实例
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // roomId: '15868806280',
    roomId: '',
    userName: '',
    audioOpenState: false,
    videoOpenState: false,
    roomList: [],
    clientVersion: config.clientVersion,

    roomIdMaxlength:13,
    isValidateRoomId:false
    
  },


  /**
   * 从曾经登陆过的房间号集合中选择会议号
   */
  chooseRoom: function() {
    var self = this;
    const itemList = [];
    for (var k of this.data.roomList) {
      itemList.push(k);
    }
    itemList.push('清除所有记录');
    wx.showActionSheet({
      itemList: itemList,
      success: function(res) {
        if (itemList[res.tapIndex] == '清除所有记录') {
          wx.setStorageSync("room_list", []);
          self.setData({
            roomList: []
          })
        } else {
          var itemValue = itemList[res.tapIndex];
          console.log(itemValue);
          if (itemValue.indexOf('sip') >= 0 || itemValue.indexOf('h323') >= 0 || itemValue.indexOf('rtsp') >= 0 || itemValue.indexOf('rtmp') >= 0 || itemValue.indexOf('auto') >= 0) {
              self.setData({
                roomIdMaxlength: 40
              })
          } else {
               self.setData({
                 roomIdMaxlength: 13
               })
          }
          self.setData({
            roomId: itemValue
          })
        }
      },
      fail: function(res) {
        console.log(res.errMsg)
      }
    })
  },


  /**
   * 音频开启关闭事件
   */
  openAudioChange: function() {
    this.setData({
      audioOpenState: !this.data.audioOpenState,
    });
  },


  /**
   * 视频开启关闭事件
   */
  openVideoChange: function() {
    this.setData({
      videoOpenState: !this.data.videoOpenState,
    });
  },


  /**
   * 获取用户信息回调
   */
  onGotUserInfo: function(e) {
    if (e.detail.userInfo) {
      this.setData({
        userName: e.detail.userInfo.nickName
      })
    }
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    app.data.userInfo.userId = wx.getStorageSync('user_id') ? wx.getStorageSync('user_id') : '';
    app.data.userInfo.roomToken = wx.getStorageSync('room_token') ? wx.getStorageSync('room_token') : '';
    app.data.userInfo.siteId = wx.getStorageSync('site_id') ? wx.getStorageSync('site_id') : '';
    app.data.avdSDK.serverInfo.avdServerUrl = wx.getStorageSync('avd_server_uri') ? wx.getStorageSync('avd_server_uri') : '';
    
    //用户昵称获取
    var userName = wx.getStorageSync("user_name") ? wx.getStorageSync("user_name") : this.data.userName;
    if (!userName) {
        if (getApp().data.userInfo.userName){
           userName = getApp().data.userInfo.userName;
        }
    }
    this.setData({
      userName: userName
    })


    //扫普通链接二维码打开小程序方式进入，解析房间号参数
    if (options.q) {
      var src = decodeURIComponent(options.q);
      var srcSplits = src.split("id=");
      if (srcSplits && srcSplits.length > 1) {
        console.log("扫普通链接二维码打开小程序方式进入,roomId:", srcSplits[1]);
        this.setData({
          roomId: srcSplits[1],
        })
      }
    }

    //扫微信二维码打开小程序方式进入，解析房间号参数
    if (options.roomId) {
      this.setData({
        roomId: options.roomId,
      })
    }

    //曾经登陆过的房间号获取(只存最近登陆的5个)
    this.data.roomList = wx.getStorageSync("room_list") ? wx.getStorageSync("room_list") : [];
  },


  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {
    
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function() {

  },
  toSetting: function(){
    wx.navigateTo({
      url: "../touchSetting/touchSetting",
    });
  },

  /**
   * 加入会议
   */
  joinRoom: function() {
    console.log(new Date(), "+++++join room start++++++++++" );
    
    if (this.data.isValidateRoomId == false){
        console.log(new Date(), "+++++joinRoom(),roomID格式不通过 return++++++++++");
        return;
    }
    if (this.data.userName.length == 0) {
      wx.showModal({
        title: '出错提示',
        content: "用户名不能为空！",
        showCancel: false
      });
      return;
    }
    wx.showLoading({
      title: '加会中...',
      mask: true
    })

    api.getRoomParams(this.data.roomId, '').then((data) => {
      if (data.ret == 0) {
        if (data.data.is_lock) {
          wx.hideLoading();
          wx.showModal({
            title: '出错提示',
            content: "房间已经锁定，禁止加入会议！",
            showCancel: false
          });
          return;
        }
        if (data.data.video_codec == "h264") {
          app.data.avdSDK.avdEngine.setVideoCoding(app.data.avdSDK.Enum.VideoCodingType.H264);
        } else if (data.data.video_codec == "vp8") {
          app.data.avdSDK.avdEngine.setVideoCoding(app.data.avdSDK.Enum.VideoCodingType.VP8);
        }

        if (data.data.audio_codec == "opus") {
          app.data.avdSDK.avdEngine.setAudioCoding(app.data.avdSDK.Enum.AudioCodingType.opus);
        }
        this.beforeJoin();
      }
    }).catch((error) => {
      console.log(error);
      wx.hideLoading();
      if(error.ret == 10501){
        wx.showModal({
          title: '出错提示',
          content: "请等待主持人开启本场会议后再加入会议！",
          showCancel: false
        })
      } else if (error.ret == 10502){
        wx.showModal({
          title: '出错提示',
          content: "会议号错误，请核实后再输!",
          showCancel: false
        })
      }else{
        wx.showModal({
          title: '出错提示',
          content: error.msg + "[" + error.ret + "]",
          showCancel: false
        })
      }
      
    });

  },


  beforeJoin: function() {
    var session_id = wx.getStorageSync("session_id") ? wx.getStorageSync("session_id") : "";
    if (session_id) {
      app.data.avdSDK.avdEngine.init(wx.getStorageSync("avd_server_uri"), wx.getStorageSync("room_token")).then(this.initSuccess).catch(this.initError);
    } else {
      api.getVisitoRoomToken(this.data.roomId, this.data.userName).then((data) => {
        app.data.userInfo.siteId = data.site_id;
        app.data.userInfo.userId = data.user_id;
        app.data.userInfo.userName = data.user_name;
        app.data.avdSDK.avdEngine.init(data.room_servers[0], data.room_token).then(this.initSuccess).catch(this.initError);
      }).catch((error) => {
        console.log(error);
        wx.hideLoading();
        wx.showModal({
          title: '出错提示',
          content: error.msg + "[" + error.ret + "]",
          showCancel: false
        })
      });
    }

  },

  initSuccess: function() {
    console.log(new Date(),"+++++initSuccess++++");
    app.data.avdSDK.room = app.data.avdSDK.avdEngine.obtainRoom(this.data.roomId);
    app.data.avdSDK.room.join(app.data.userInfo.userId, this.data.userName, null, null).then(this.joinSuccess).catch(this.joinError);
  },

  initError: function(e) {
    console.log(e);
    wx.hideLoading();
    wx.showModal({
      title: '出错提示',
      content: "网络故障，服务器连接超时。可刷新重试! 错误码:" + e.error.code + ",错误信息：" + e.error.message,
      showCancel: false
    })
  },

  joinSuccess: function() {
    console.log(new Date(),"+++++joinSuccess+++++");
    var self = this;

    var ownerId = app.data.avdSDK.room.getOwnerId();
    if (app.data.userInfo.userId == ownerId) {
      app.data.avdSDK.room.updateAppData(JHEnum.appDataMeeting.host, ownerId);
      app.data.hostId = ownerId;
    }
    var roomList = wx.getStorageSync("room_list") ? wx.getStorageSync("room_list") : [];
    if (roomList.indexOf(this.data.roomId) < 0) {
      if (roomList.length > 4) {
        roomList.shift();
      }
      roomList.push(this.data.roomId);
      wx.setStorageSync("room_list", roomList);
    }

    wx.hideLoading();
    var url = "../home/home?audioOpenState=" + self.data.audioOpenState + "&videoOpenState=" + self.data.videoOpenState;
    wx.reLaunch({
      url: url
    });
  },

  joinError: function(e) {
    wx.hideLoading();
    console.log(new Date(),"+++++joinError+++++", e.error);
    wx.showModal({
      title: '出错提示',
      content: "加会失败了! 错误码:" + e.error.code + ",错误信息：" + e.error.message,
      showCancel: false
    })
  },

  /**
   * 会议用户名验证
   */
  setUserName: function(e) {
    this.data.userName = e.detail.value;
  },


  /**
   * 会议号验证
   */
  setRoomId: function(e) {
    console.log("------setRoomId(),e.detail.value:", e.detail.value);
    var value = e.detail.value;
    if (value.indexOf('sip') >= 0 || value.indexOf('h323') >= 0 || value.indexOf('rtsp') >= 0 || value.indexOf('rtmp') >= 0 || value.indexOf('auto') >= 0) {
        this.setData({
          roomId:value,
          roomIdMaxlength: 40
        })
    }else{
        this.setData({
            roomIdMaxlength: 13,
           isValidateRoomId: true
        })

        var detailValue = this.changeStr(e.detail.value).replace(/^ +| +$/g, '');
        var roomId = detailValue.split('-').join('');
        this.data.roomId = roomId;

        console.log("++++++++++==setRoomId(),detailValue:", detailValue);
        //直接返回对象，可以对输入进行过滤处理，同时可以控制光标的位置
        return {
          value: detailValue
        }
       
    }
  },


  validateRoomId: function(e){
      var value = e.detail.value;
      console.log("+++++=validateRoomId(),value:", value);
      let regExp = /^/;
      if (value.indexOf('sip') >= 0) {
          this.setData({
             roomIdMaxlength: 40
          })
          regExp = /^(sip)(([\:][\d]{1,15})|)(\@)([a-zA-Z0-9\.]{1,10}){1,4}((\:[\d]{1,6})|$)/;
      } else if (value.indexOf('h323') >= 0) {
        this.setData({
          roomIdMaxlength: 40
        })
          regExp = /^(h323)(([\:][\d]{1,15})|)(\@)([a-zA-Z0-9\.]{1,10}){1,4}((\:[\d]{1,6})|$)/;
      } else if (value.indexOf('rtsp') >= 0) {
        this.setData({
          roomIdMaxlength: 40
        })
          regExp = /^(rtsp)+\:\/\/[^\s]*/;
      } else if (value.indexOf('rtmp') >= 0) {
        this.setData({
          roomIdMaxlength: 40
        })
          regExp = /^(rtmp)+\:\/\/[^\s]*/;
      } else if (value.indexOf('auto') >= 0) {
        this.setData({
          roomIdMaxlength: 40
        })
          regExp = /^(auto)+\:[^\s]*/;
      } else{
        this.setData({
           roomIdMaxlength: 13
        })
      }    
           
      if (regExp.test(value) === false) {
          console.log('会议号格式不对,value:', value);
              
          wx.showModal({
                 title: '出错提示',
                 content: '会议号格式不对',
                 showCancel: false
          })
          this.data.isValidateRoomId = false;
          return;
      }else{
          this.data.isValidateRoomId = true;
      }
  },



  changeStr: function(str) {
    var self = this;
    str = str.split('-').join('');
    if (str.length > 7) {
      str = self.insert_flg(str, '-', 3);
      str = self.insert_flg(str, '-', 8);
    } else if (str.length > 3) {
      str = self.insert_flg(str, '-', 3);
    }
    return str;
  },


  insert_flg(str, flg, sn) {
    var str = str.split('');
    str.splice(sn, 0, '-');
    str = str.join('');
    return str;
  },

  strlen(str) {
    var len = 0;
    for (var i = 0; i < str.length; i++) {
      var c = str.charCodeAt(i);
      //单字节加1 
      if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
        len++;
      } else {
        len += 2;
      }
    }
    return len;
  },

})