
var serverURL = 'avd.nice2meet.cn:9609';  

var accessKey = 'demo_access';
var secretKey = 'demo_secret';
var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var userName = 'user' + parseInt(Math.floor(Math.random () * 9000) + 1000);

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);  
var avdEngine = new AVDEngine();

avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
avdEngine.initDevice();

var restApi = new RestApi(serverURL);

var camera = document.getElementById("camera");
var canvas = window.canvas = document.querySelector('canvas');

var self = this;


restApi.getAccessToken (accessKey , secretKey).then((res) => {
    console.log('Success',res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error",error);
})

//创建房间
function createRoom(){
    var topic = 'testingMeeting';
    restApi.createRoom (self.accessToken, topic, self.userId).then((res) => {
        console.log('Success',res)
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        console.log("Error",error)
    })
}

//  加入会议
function joinRoom () {
    if(room) {return}
    
    self.roomId = $("#first").val();
    avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
}

//  初始化成功
function initSuccess () {
    room = avdEngine.obtainRoom(self.roomId);
    room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//  初始化失败
function initError (error) {
    console.log('initError()error:',error);
}

//  加入房间成功
function joinSuccess () {
    console.log('加入会议成功');

    openCamera();
}

//  加入房间失败
function joinError (error) {
    console.log('joinError()error:',error);
}

function openCamera () {
    var videos = room.selfUser.videos;
    if(videos && videos.length > 0){
        var video = videos[1]; 
        if(video){
            video.previewAndPublish(camera).otherwise(showError);
        }
    }
}

function showError (error) {
    console.log('WWWWWWWWWWWWWWWshowError()error:', error);
}


//点击进行截图，需要传入video元素
function screenshots() {
    canvas.width = camera.videoWidth;
    canvas.height = camera.videoHeight;
    canvas.getContext('2d').drawImage(camera, 0, 0, canvas.width, canvas.height);
    saveAndUpload();

}

//保存并上传图片
function saveAndUpload() {
    var strDataURI = canvas.toDataURL("image/png").replace("image/png", "image/octet-stream");
    var test = dataURLtoFile(strDataURI, 'test.png');
    console.log('11111111111111',test);
    changefile(test);
}
var imageURL;
function changefile(file, room_id){
    var forms = new FormData()
    var configs = {
      headers:{'Content-Type':'multipart/form-data'}
    };
    
    forms.append('file',file);

    if(!room_id) {
    	   room_id = roomId;
    }
    var url = document.location.protocol + '//' + serverURL + '/sdkapi/v2/file/upload_file?token=' +  accessToken + '&room_id=' + room_id + '&user_id=' + userId;
    
    
    this.axios.post(url ,forms ,configs).then((res)=>{
        console.log(res)
        if(res.data.ret == 0) {
            imageURL = res.data.file_path;
        } else {
            console.log('==========changefile()上传失败' + res.data.msg + '[' + res.data.ret + ']')
        }
    }).catch((error) => {
        console.log('==========changefile()上传失败error:' + error)
    })
}

function dataURLtoFile(dataurl, filename) {
    var arr = dataurl.split(','), mime = arr[0].match(/:(.*?);/)[1],
    bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
    while(n--){
      u8arr[n] = bstr.charCodeAt(n);
    }
    return new File([u8arr], filename, {type:mime});
}

function viewImage() {
    window.open(imageURL)
}

function submit() {
    var files = document.getElementById('file').files;
    for (var i = 0, ilen = files.length; i < ilen; i++) {
        console.log(files[i]);
        changefile(files[i], 50133811148);
    }

}

//退会
function leaveRoom () {
    if (!room) { return }
    var reason = 1; //退会原因
    room.leave(reason).then(function () {
        window.location.reload();
        return false;
    });
}