var serverURL = 'box.nice2meet.cn';

var accessKey = 'demo_access';
var secretKey = 'demo_secret';
var accessToken = null;

var userId = null;
var userName = null;

var roomId = null;
var clientName = null;
var remoteAssistanceState = 0; //远程协助状态   0-未开始  1-进行中
var ieRemoteAssistanceState = 0;

var currentBoardUserId = null;
var currentBoardId = null;
var currentBoard = null;

var client, inviteManager, rpcManager, acceptInvite;
var mainBox = document.getElementById('mainBox');
var loginBox = document.getElementById('loginBox');
var inviteBox = document.getElementById('inviteBox');
var dataShow = document.getElementById('dataShow');
var operationInterface = document.getElementById('operationInterface');
var remoteCooperationHint = document.getElementById('remoteCooperationHint');

var boardWidth, boardHeight, boardOutputWidth, boardOutputHeight;

var localVideo = document.getElementById("localVideo");
var clientVideo = document.getElementById("clientVideo");
var clientAudio = document.getElementById("clientAudio");
var businessVideo = document.getElementById("businessVideo");
var boardBtn = document.getElementById('boardBtn');

var callArea = document.getElementById('callArea');

var activeX;
var ieIsShowOperat = document.getElementById('ieIsShowOperat');

var snapshotAreaEnum = {
	customerArea: 'customerArea', //客户区域
	serviceArea: 'serviceArea', //座席区域
	businessArea: ' businessArea', // 业务区域
}

var self = this;

var currentSeatingStatus = 0;  //当前座席状态： 0-空闲，1-忙碌

var protocolStr = document.location.protocol;
var httpHost = window.location.host;
var hostname = window.location.hostname;
if(httpHost && hostname != "localhost" && hostname !="127.0.0.1" && httpHost != "192.168.1.13:8081"){
	serverURL = httpHost;
}
var restApi = new RestApi(serverURL);
console.log("==================serverURL:",serverURL);

function isIE() {
	if (!!window.ActiveXObject || "ActiveXObject" in window) {
		return true;
	} else {
		return false;
	}
}

if (!isIE()) {
	var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);
	var avdEngine = new AVDEngine();
	avdEngine.setLog(Appender.browserConsole, LogLevel.debug);
	avdEngine.setVideoCoding(VideoCodingType.H264);
	avdEngine.initDevice();
} else {
	var activeXUrl = protocolStr + '//' +serverURL + "/download/dr/1.0/DRActvX.cab#version =1,0";
	console.log('=============activeXUrl:', activeXUrl);
	var object = document.createElement('object');

	object.setAttribute('id', "DBActiveX");
	object.setAttribute('classid', "clsid:38BBB338-28EA-4419-A8B0-B8A56564821F");
	object.setAttribute('codebase','./ocx/DRActvX.cab#version =1,0');

	var callInterface = document.querySelector('.callInterface');
	callInterface.appendChild( object );
	activeX = document.getElementById("DBActiveX");


	activeX.attachEvent("onUserJoin", onUserJoin);
	activeX.attachEvent("onUserLeave", onUserLeave);
	// activeX.updateCameraData(0,'{"video_name":"客服"}');
}

function onUserJoin(userId,userName){
	console.log('============WWWWWWWWWWonUserJoinuserId', userId)
	console.log('============WWWWWWWWWWonUserJoinuserName', userName)
}

function onUserLeave(userId,userName){
	console.log('============WWWWWWWWWWonUserLeaveuserId', userId)
	console.log('============WWWWWWWWWWonUserLeaveuserName', userName)
}

restApi.getAccessToken(accessKey, secretKey).then(function (res) {
	console.log('Success', res)
	accessToken = res.token;
}).otherwise(function (error) {
	console.log("Error", error);
	$(".loginMsg").html('getAccessToken(),error:' + error.msg);
})

//登录
function login() {
	$(".errorMsg").html('');
	var account = $('#account').val();
	var userPasswrod = $('#userPasswrod').val();
	if (account == '') {
		$(".errorMsg").html('用户帐号不能为空');
		return
	}

	var Client = ModuleBase.use(ModulesEnum.client);
	client = new Client(serverURL, accessToken);

	if (isIE()) {
		client.setLog(Appender.browserConsole, LogLevel.debug);
	}

	client.login(account, userPasswrod).then(function () {
		console.log('信令注册登录成功');

		inviteManager = client.getInviteManager();
		rpcManager = client.getRpcManager();
		registerInviteManagerCallback();

		userId = account;
		userName = account;

		$('#userNameSpan').text(userName);
		seatingStatusRender();

		mainBox.style.display = 'block';
		loginBox.style.display = 'none';
	}).otherwise(function (error) {
		console.log('信令注册登录失败！' + error.message + "[" + error.code + ']');
		$(".errorMsg").html('登录失败！' + error.message + "[" + error.code + ']');
	});
}

//登出
function exit() {
	if (client) {
		var reson = "";
		client.logout(reson).then(function () {
			console.log('登出成功');
			location.reload();
		}).otherwise(function (error) {
			errorPromptShow('登出失败！error:' + error.message + '[' + error.code + ']');
			console.log('登出失败！' + error.code + '/' + error.message);
		});
	}
}


/**
 * 注册InviteManager级别回调 
 */
function registerInviteManagerCallback() {
	inviteManager.addCallback(inviteManager.InviteManagerCallbackEnum.CALL_NOTIFY, onCall);
}


function onCall(invite) {
	acceptInvite = invite;
	registerInviteCallback(invite);
	self.invite = invite;

	invite.ringing().then(function () {
		console.log("发送振铃成功");

		roomId = invite.options.roomId;
		clientName = invite.toUserId;
		$('#clientNameSpan').text(clientName);
		$('#clientName').text(clientName);

		inviteBox.style.display = 'block';
	}).otherwise(function (error) {
		log.error("发送振铃失败。error：", error);
		errorPromptShow('发送振铃失败.error:' + error.message + '[' + error.code + ']');
	})
}


/**
 * 注册Invite级别回调 
 */
function registerInviteCallback(invite) {
	invite.addCallback(invite.InviteCallbackEnum.CALL_CANCEL_NOTIFY, onCallCancel);
	invite.addCallback(invite.InviteCallbackEnum.RESPONSE_CALL_TIMEOUT_NOTIFY, onResponseCallTimeout);

	invite.addCallback(invite.InviteCallbackEnum.CALL_CLOSE_NOTIFY, onCallClose);
}

//邀请发启者取消邀请的回调
function onCallCancel(fromUserId) {
	console.log("======onCallCancel()=====fromUserId:" + fromUserId);
}

//接收邀请者无响应，超时回调
function onResponseCallTimeout(fromUserId) {
	console.log("======onResponseCallTimeout()=====fromUserId:" + fromUserId);
	errorPromptShow('收到邀请，未作出响应，已超时');
	inviteBox.style.display = 'none';
}

function onCallClose(fromUserId, reson) {
	console.log("======onCallClose()=====fromUserId:" + fromUserId + ";reson:" + reson);
	console.log('WWWWWWWWWWWWW@@@@@@@@@@@@@@');
	errorPromptShow(fromUserId + "已挂断了操作");
	dataShow.style.display = 'flex';
	operationInterface.style.display = 'none';

	if(isIE()){
		activeX.leaveRoom(0);
	}
}


function reject() {
	inviteBox.style.display = 'none';

	var reson = 'No reason'
	acceptInvite.reject(reson).then(function () {
		console.log('拒绝邀请成功。');
	}).otherwise(function (error) {
		errorPromptShow('拒绝邀请失败。error:' + error.message + '[' + error.code + ']');
		log.error('拒绝邀请失败。error：', error);
	})
}

var jobNumber = '9999990000';
var logoUrl = protocolStr + '//' +serverURL +'/home/9610_box/www/r/static/img/customImg/smallLogo.png'

function accept() {
	self.invite.accept().then(function () {
		console.log('接受邀请成功。');
		console.log("=============接受端加入会议：roomId:", roomId);

		inviteBox.style.display = 'none';
		dataShow.style.display = 'none';
		if (isIE()) {
			operationInterface.style.display = 'flex';
			activeX.style.display = 'block';
			callArea.style.display = 'none';
			ieIsShowOperat.style.display = 'block';
			
			var activeXUrl = protocolStr + '//' + serverURL;
			console.log('===========activeXUrl:', activeXUrl);
			activeX.joinRoom(activeXUrl, accessKey, secretKey, clientName, userId, roomId, jobNumber, logoUrl);
			activeX.attachEvent("onJoinResult", onJoinResult);

			var bedienfeldData = initBedienfeldData();
			$("#bedienfeld").append(bedienfeldData);

		} else {
			operationInterface.style.display = 'flex';
			var bedienfeldData = initBedienfeldData();
			$("#bedienfeld").append(bedienfeldData);

			setRemoteAssistanceState();
			joinRoom();
		}

	}).otherwise(function (error) {
		errorPromptShow('接受邀请失败。error:' + error.message + '[' + error.code + ']');
		log.error('接受邀请失败。error：', error);
	})
}

function onJoinResult(code, message) {
	if (code == 0) {
		console.log('=================onJoinResult(): 加会成功', message);
	} else {
		console.log('=================onJoinResult(): 加会失败', message);
		errorPromptShow('加会失败: error:' + message);
	}
}


//加入会议
function joinRoom() {
	if (!roomId) {
		return
	}
	avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
}

//初始化成功
function initSuccess() {
	room = avdEngine.obtainRoom(self.roomId);
	room.join(self.userId, self.userName, '', '').then(joinSuccess).otherwise(joinError);
}

//初始化失败
function initError(error) {
	console.log("AVDEngine 初始化失败！initError(),error:" + error.message);
	errorPromptShow("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//加入房间成功
function joinSuccess() {
	console.log('加入会议成功');

	//自动打开音视频
	openCamera();
	openMicrophone();

	//注册房间回调
	registerRoomCallback();

	onPublishCameraNotify(room.pubVideos); //加会登陆前，会议中已经发布的视频资源,采取订阅处理
	onPublishScreenNotify(room.pubScreens); //加会登陆前，会议中已经发布的桌面共享资源,采取订阅处理);

	participantsHandle(room.getParticipants());
}

//  加入房间失败
function joinError(error) {
	if (error.code == 404) {
		console.log("加会失败！原因房间没有找到，请核实。joinError(),error");
		errorPromptShow("加会失败！原因房间没有找到，请核实。joinError(),error");
		hangup();
	} else {
		errorPromptShow('加会失败,error:' + error.message + "[" + error.code + "]");
		console.log('joinError(),error:' + error.message + "[" + error.code + "]");
		hangup();
	}
}


/**
 * 打开摄像头
 */
function openCamera() {
	videos = room.selfUser.videos;
	if (videos && videos.length > 0) {
		var video = videos[0];
		if (video) {
			video.updateCameraData(null,'{"video_name":"客服"}');
			video.previewAndPublish(localVideo).otherwise(showError);
		}
	}
}
		
/**
 * 打开麦克风
 */
function openMicrophone() {
	var audio = room.selfUser.audio;
	if (audio) {
		audio.openMicrophone().otherwise(showError);
	}
}

function showError(error) {
	errorPromptShow('操作失败,error:' + error.message + "[" + error.code + "]");
	console.log('showError(),error:' + error.message + "[" + error.code + "]");
}

//注册房间回调
function registerRoomCallback() {
	room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
	room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);

	room.addCallback(RoomCallback.private_data, onPrivateData);
}


/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
	console.log("============onUserJoinNotify(),users:", users);
	participantsHandle(users);
}


/**
 * @desc 参会者退会回调
 * @param {int} opt - 退会类型
 * @param {int} reason  - 退会原因
 * @param {Object} user - 退会用户
 */
function onUserLeaveNotify(opt, reason, user) {
	console.log("===========onUserLeaveNotify(),user:", user);
	//服务器端报807错误，说明UDP不通或UDP连接超时
	if (reason == 807) {
		errorPromptShow("807错误，UDP不通或UDP连接超时！");
		console.log("onUserLeaveNotify(),807错误，UDP不通或UDP连接超时！");
		return;
	}

	if (reason == 812) {
		console.log('==========onUserLeaveNotify()',user.id + '已异常退会');
		errorPromptShow(user.id + '已异常退会');
	} else {
		console.log('==========onUserLeaveNotify()',user.id + '已退会');
		errorPromptShow(user.id + '已退会');
	}

	if (user.userAgent != 'avd_mp4_importer') {
		hangup();

	}
}

/**
 * 私有透明通道回调
 * @param {Object} dataArrayBuffer － DataArrayBuffer对象
 * @param {String} userId － user id
 */
function onPrivateData(dataArrayBuffer, userId) {
	var content = typeConversionUtil.ArrayBuffer2String(dataArrayBuffer);
	console.log("=========================onPrivateData(),content:", content);
	var jsonObj = JSON.parse(content);
	console.log("=========================onPrivateData(),jsonObj:", jsonObj);
	if (jsonObj.cmd == 501) {
		if (jsonObj.content.type == 'call') {
			console.log("==================onPrivateData(),type=call");
			//TODO

		} else if (jsonObj.content.type == 'accept') {
			console.log("==================onPrivateData(),type=accept");

			//进行视频上的批注
			remoteAssistanceState = 1;
			setRemoteAssistanceState();
			createBoard();
			boardBtn.style.display = 'block';
		} else if (jsonObj.content.type == 'reject') {
			console.log("==================onPrivateData(),type=reject");
			errorPromptShow(userId + '拒绝了您开启远程协助的请求');

		} else if (jsonObj.content.type == 'close') {
			console.log("==================onPrivateData(),type=close");
			remoteAssistanceState = 0;
			setRemoteAssistanceState();
			boardBtn.style.display = 'none';
			removeBoard();

		}
	}
}

/**
 * @desc  用户回调事件
 * @param {Object} participants - 用户集数组
 */
function participantsHandle(participants) {
	participants.forEach(function (user) {
		user.addCallback(UserCallback.camera_status_notify, onCameraStatusNotify);
		user.addCallback(UserCallback.microphone_status_notify, onMicrophoneStatusNotify);

		user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
		user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
		user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
		user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);

		user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
		user.addCallback(UserCallback.unsubscrible_microphone_result, onUnsubscribleMicrophoneResult);

		user.addCallback(UserCallback.publish_screen_notify, onPublishScreenNotify);
		user.addCallback(UserCallback.unpublish_screen_notify, onUnpublishScreenNotify);
		user.addCallback(UserCallback.subscrible_screen_result, onSubscribleScreenResult);
		user.addCallback(UserCallback.unsubscrible_screen_result, onUnsubscribleScreenResult);
	})
}


/**
 * 摄像头状态更新
 * @param {Object} status － 状态
 * @param {Object} cameraId － 摄像头设备Id
 * @param {Object} cameraName－ 摄像头设备名称
 * @param {Object} userId－ 摄像头设备所属者ＩＤ
 */
function onCameraStatusNotify(status, cameraId, cameraName, userId) {
	console.log("===============onCameraStatusNotify(),cameraId:", cameraId, "status:", status);
}


/**
 * 麦克风状态更新
 * @param {Object} status － 状态
 * @param {Object} microphoneId － 麦克风设备Id 
 * @param {Object} microphoneName － 麦克风设备名称
 * @param {Object} userId － 麦克风设备所属者ＩＤ
 */
function onMicrophoneStatusNotify(status, microphoneId, microphoneName, userId) {
	console.log("===============onMicrophoneStatusNotify(),microphoneId:", microphoneId, "status:", status);
}


//订阅未订阅的视频
function onPublishCameraNotify(videos) {
	console.log("=======================onPublishCameraNotify(),videos:", videos);
	for (var j = 0; j < videos.length; j++) {
		var video = videos[j];
		var user = room.getUser(video.ownerId);
		if (user && user.userAgent == 'avd_mp4_importer') {
			continue;
		}

		//只订阅未订阅过的视频
		var subVideoIdsLen = room.selfUser.subVideoIds.length;
		if (subVideoIdsLen > 0) {
			var isSub = false;
			for (var i = 0; i < subVideoIdsLen; i++) {
				var videoId = room.selfUser.subVideoIds[i];
				if (video.id == videoId) {
					isSub = true;
					break;
				}
			}
			if (!isSub) {
				video.subscrible();
			}
		} else {
			video.subscrible();
		}
	}
}


/**
 * 订阅远端视频流反馈
 * @param {Object} stream － 远端视频流
 * @param {Object} userId － 所属用户ＩＤ
 * @param {Object} userName－ 所属用户名称
 * @param {Object} cameraId－ 摄像头设备ＩＤ
 */
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
	console.log("=======================onSubscribleCameraResult(),userId:", userId);
	console.log("=======================onSubscribleCameraResult(),cameraId:", cameraId);
	room.selfUser.attachVideoElementMediaStream(clientVideo, stream);
}


/**
 * 房间中发布的视频回调
 * @param {Object} video-发布视频集
 */
function onUnpublishCameraNotify(video) {
	console.log("=======================onUnpublishCameraNotify(),video:", video);
	video.unsubscrible();
}


/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
	console.log("=======================onUnsubscribleCameraResult(),userId:", userId);
	room.selfUser.attachVideoElementMediaStream(clientVideo, null);
}


/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onSubscribleMicrophoneResult(stream, userId, userName) {
	console.log("=======================onSubscribleMicrophoneResult(),userId:", userId);
	room.selfUser.attachAudioElementMediaStream(clientAudio, stream);
}


/**
 * 取消订阅远端音频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */
function onUnsubscribleMicrophoneResult(userId, userName) {
	console.log("=======================onUnsubscribleMicrophoneResult(),userId:", userId);
	room.selfUser.attachAudioElementMediaStream(clientAudio, null);
}

function onPublishScreenNotify(screens) {
	console.log('==============WWWWWWWWW000000',screens);
	screens.forEach(function (screen) {
		//只订阅未订阅过的桌面共享
		var isSub = false;
		var subScreenIdsLen = room.selfUser.subScreenIds.length;
		if (subScreenIdsLen > 0) {
			for (var i = 0; i < subScreenIdsLen; i++) {
				var screenId = room.selfUser.subScreenIds[i];
				if (screen.id == screenId) {
					isSub = true;
					break;
				}
			}
			if (!isSub) {
				console.log('============WWWWWWWWWWWW1111111111', screen);
				if (screen.resourceInfo.stream.stream_name.indexOf('businessVideoFictitious') >= 0) {
					screen.subscrible();
				}
			}
		} else {
			console.log('============WWWWWWWWWWWW222222222222', screen);
			if (screen.resourceInfo.stream.stream_name.indexOf('businessVideoFictitious') >= 0) {
				screen.subscrible();
			}
		}
	});
}

function onUnpublishScreenNotify(screen) {
	screen.unsubscrible();
}



function onSubscribleScreenResult(stream, userId, userName, screenId, width, height, framerate) {
	console.log("=======onSubscribleScreenResult(),width:" + width + ",height:" + height + ",framerate:" + framerate);
	if (screenId == userId + '_businessVideoFictitious') {
		room.selfUser.attachScreenElementMediaStream(businessVideo, stream);

		videoHandleSuccess(stream, width, height);
	}
}

function videoHandleSuccess(stream, width, height) {
	businessVideo.srcObject = stream;

	var videoWidth = $('#businessVideo').width();
	var videoHeight = $('#businessVideo').height() - 40;
	var videoTrackWidth = width;
	var videoTrackHeight = height;

	var videoHeightTemp = (videoWidth * videoTrackHeight) / videoTrackWidth;
	var videoWidthTemp = (videoHeight * videoTrackWidth) / videoTrackHeight;
	boardOutputWidth = width;
	boardOutputHeight = height;
	//等宽截高
	if (videoHeightTemp < videoHeight) {
		console.log("===========等宽截高==videoWidth:" + videoWidth + ";videoHeight:" + videoHeightTemp);
		boardWidth = videoWidth;
		boardHeight = videoHeightTemp;
	}

	//等高截宽
	if (videoWidthTemp < videoWidth) {
		console.log("===========等高截宽==videoWidth:" + videoWidthTemp + ";videoHeight:" + videoHeight);
		boardWidth = videoWidthTemp;
		boardHeight = videoHeight;
	}
}

function onUnsubscribleScreenResult(userId, userName, screenId) {
	room.selfUser.attachScreenElementMediaStream(businessVideo, null);
}

//挂断
function hangup() {
	//关闭房间
	room.closeRoom(room.selfUser.id);

	if (acceptInvite) {
		acceptInvite.close("invice close").then(function () {
			console.log("invivte 关闭成功");
			dataShow.style.display = 'flex';
			operationInterface.style.display = 'none';

			roomId = null;
			clientName = null;
			$("#bedienfeld").html("");
		}).otherwise(function (error) {
			console.log("挂断失败。error:", error);
			errorPromptShow('挂断失败。error:' + error.message + "[" + error.code + "]");
		})
	}
}

function ieHangup() {

	if (acceptInvite) {
		acceptInvite.close("invice close").then(function () {
			console.log("invivte 关闭成功");
			dataShow.style.display = 'flex';
			operationInterface.style.display = 'none';

			roomId = null;
			clientName = null;
			$("#bedienfeld").html("");
		}).otherwise(function (error) {
			console.log("挂断失败。error:", error);
			errorPromptShow('挂断失败。error:' + error.message + "[" + error.code + "]");
		})
	}

	activeX.leaveRoom(0);
}

function menuShow(dom) {
	var menuDom = document.getElementById(dom);
	var menuDomShow = menuDom.style.display;
	if (menuDomShow == 'none') {
		menuDom.style.display = 'block';
	} else {
		menuDom.style.display = 'none';
	}
}

var span = document.querySelectorAll('.tab span');
var tabpane = document.querySelectorAll('.tabpane');

for (var i = 0; i < span.length; i++) {
	span[i].idx = i;
	span[i].onclick = function () {
		for (var j = 0; j < tabpane.length; j++) {
			tabpane[j].style.display = 'none';
			span[j].classList.remove('active');
		}
		tabpane[this.idx].style.display = 'block';           //给当前div显示出来
		this.classList.add('active');
	}
}

function buttonShow() {
	var btn = document.getElementById('exit');
	console.log(btn.style.display)

	if (btn.style.display == 'block') {
		btn.style.display = 'none';
	} else {
		btn.style.display = 'block';
	}
}

function errorPromptShow(error) {
	$('#errorPromptMsg').text(error);
	$('#errorPrompt').fadeIn(1000, function () {
		setTimeout(function () {
			$('#errorPrompt').fadeOut(1000)
		}, 5000)
	});
}

var compare = function (prop) {
	return function (obj1, obj2) {
		var val1 = obj1[prop];
		var val2 = obj2[prop];
		if (val1 < val2) {
			return -1;
		} else if (val1 > val2) {
			return 1;
		} else {
			return 0;
		}
	}
}

function seatingStatusRender() {
	if (currentSeatingStatus == 0) {
		$('#seatingStatus').html('置忙');

		$('.state i').css({
			'background': '#00cc99'
		})
	} else {
		$('#seatingStatus').html('置闲');
		$('.state i').css({
			'background': '#f00'
		})
	}
}

function setSeatingStatus() {
	var status = 0;
	if (currentSeatingStatus == 0) {
		status = 1;
	}
	var jsonObj = {
		"jsonrpc": "2.0",
		"id": "100",
		"method": "setSeatingStatus",
		"params": {
			"account": userName,
			"status": status
		}
	};

	rpcManager.call(jsonObj).then(function (result) {
		console.log("设置座席状态成功, result :", result);
		errorPromptShow('设置座席状态成功!');

		currentSeatingStatus = status;
		seatingStatusRender();
	}).otherwise(function (error) {
		console.log("设置座席状态失败。error:", error);
		errorPromptShow('设置座席状态失败。error:' + error.message + "[" + error.code + "]");
	})
}

//操作区内容渲染
function initBedienfeldData() {
	console.log("==============bedienfeld.data:", bedienfeld.data);

	var subjectArr = bedienfeld.data.sort(compare("order"));
	console.log("============subjectArr:", subjectArr);

	var str = "";
	$.each(subjectArr, function (i, item) {
		str = str + "<div class='operationPublic'>";
		str = str + "<div class='title'>";
		str = str + "<div class='onLeft'>";
		str = str + "<i class='readIcon'></i>";
		str = str + "<span>" + item.title + "</span>";
		str = str + "</div>";

		var itemArr = item.list;
		if (itemArr.length > 1) {
			itemArr = itemArr.sort(compare("order"));
			str = str + "<div class='onRight'>";
			str = str + "<i class='okIcon'></i>";
			str = str + "<span>X" + item.list.length + "</span>";
			str = str + "</div>";
		}
		str = str + "</div>";

		console.log("==========itemArr:", itemArr);
		str = str + "<ul>";
		$.each(itemArr, function (j, detailed) {
			str = str + "<li>";
			str = str + "<span>" + detailed.name + "</span>";
			str = str + "<button onclick='sendBedienfeld(\"" + item.type + "\",\"" + item.title + "\",\"" + detailed.id + "\",\"" + detailed.name + "\",\"" + detailed.extensions + "\",\"" + detailed.actionURL + "\");'>推送给用户</button>";
			str = str + "</li>";
		});
		str = str + "</ul>";
		str = str + "</div>";
	});
	return str;
}


//操作区推送给用户
function sendBedienfeld(itemType, itemTitle, detailedId, detailedName, extensions, actionURL) {
	console.log("===============itemType:", itemType);
	console.log("===============itemTitle:", itemTitle);
	console.log("===============detailedNId:", detailedId);
	console.log("===============detailedName:", detailedName);
	console.log("===============extensions:", extensions);
	console.log("===============actionURL:", actionURL);

	var appJosn = {
		cmd: 500,
		fromUserId: clientName,
		content: {
			id: detailedId,
			type: itemType,
			title: itemTitle,
			name: detailedName,
			extensions: extensions,
			actionURL: actionURL
		}
	}

	console.log("=============================sendBedienfeld(),appJosn:", appJosn);

	var appJsonStr = JSON.stringify(appJosn);

	if (isIE()) {
		appJsonStr = btoa(unescape(encodeURIComponent(appJsonStr)))
		activeX.sendPrivateData(appJsonStr,clientName);
	} else {
		var dataArrayBuffer = typeConversionUtil.String2ArrayBuffer(appJsonStr);
		room.sendPrivateData(dataArrayBuffer, clientName).then(function dataSendSuccess(dataMsg) {
			console.log("sendBedienfeld(), sendPrivateData()...success ");
		}).otherwise(function dataSendError(error) {
			console.log("sendBedienfeld(), sendPrivateData()...error:", error);
			errorPromptShow('操作区推送给用户操作失败。error:' + error.message + "[" + error.code + "]");
		});
	}

}

function setRemoteAssistanceState() {
	if (remoteAssistanceState == 0) {
		remoteCooperationHint.style.display = 'none';
		$('.business').height('59%');
		$('#remoteAssistanceState').html("开启");
	} else if (remoteAssistanceState == 1) {
		remoteCooperationHint.style.display = 'block';
		$('.business').height('52.6%');
		$('#remoteAssistanceState').html("关闭");
	}
}


//远程协助处理，如开启/结束
function remoteAssistanceHandle() {
	if (remoteAssistanceState == 0) {  //start
		remoteAssistanceStart();
	} else if (remoteAssistanceState == 1) { //end
		remoteAssistanceEnd();
	}
}

function ieRemoteAssistanceHandle() {
	if (ieRemoteAssistanceState == 0) {  //start
		activeX.enableTeamViewer(true);
		activeX.openTeamViewer();
		activeX.attachEvent("onOpenTeamViewerResult", onOpenTeamViewerResult);
	} else if (ieRemoteAssistanceState == 1) { //end
		ieRemoteAssistanceState = 0;
		activeX.closeTeamViewer();  
		console.log('==============activeX.closeTeamViewer');
		$('#ieRemoteAssistanceState').html("开启");
	}
}

function onOpenTeamViewerResult(code, message) {
	if (code == 0) {
		console.log('=================onOpenTeamViewerResult(): 开启远程协助成功', message);
		ieRemoteAssistanceState = 1;
		$('#ieRemoteAssistanceState').html("关闭");
	} else {
		console.log('=================onOpenTeamViewerResult(): 开启远程协助失败', message);
		activeX.closeTeamViewer();  
		ieRemoteAssistanceState = 0;
		$('#ieRemoteAssistanceState').html("开启");
		errorPromptShow('开启远程协助失败 error:' + message + "[" + code + "]");
	}
}

function createBoard() {
	var backgroundColor = '0,0,0,0';
	var backgroundImage = '';
	var board = room.selfUser.createBoard(parseInt(boardWidth), parseInt(boardHeight), backgroundColor, backgroundImage);
	createBoardHandle(board);
}

function createBoardHandle(board) {
	var boardsDiv = document.getElementById("boardsDiv");

	currentBoardUserId = board.userId;
	currentBoardId = board.id;
	currentBoard = board;

	var newBoardDiv = document.createElement("Div");
	newBoardDiv.id = "board_" + board.id;
	newBoardDiv.style.width = board.width + "px";
	newBoardDiv.style.height = board.height + "px";
	newBoardDiv.style.position = 'absolute';
	newBoardDiv.style.top = 0;
	// TODO
	newBoardDiv.style.left = ($('#businessVideo').width() - parseInt(boardWidth)) / 2 + 'px';
	console.log('===========QQQQQQQQQQQQQQQQ',  ($('#businessVideo').width() - parseInt(boardWidth)) / 2 + 'px');

	newBoardDiv.boardUserId = board.userId;
	newBoardDiv.boardId = board.id;

	newBoardDiv.ondblclick = function () {
		changBorad(this.boardUserId, this.boardId);
	};

	var newBoardCanvas = document.createElement("Div");
	newBoardCanvas.style.width = "100%";
	newBoardCanvas.style.height = "100%";
	newBoardCanvas.style.background = "rgba(" + board.backgroundColor + ")";
	newBoardCanvas.style.position = 'relative';

	newBoardDiv.appendChild(newBoardCanvas);

	boardsDiv.appendChild(newBoardDiv);

	board.createAnnotation().then(function (annotation) {
		annotation.init(newBoardCanvas);
		board.annotation.hlightPointInit('./images/icon-laserPen-move.png', 25, 25);
		changBorad(board.userId, board.id);
	});
	currentBoard.annotation.setColor('(255,0,0,1)');
}

function settingOut() {
	currentBoard.annotation.setArrowType(arrowTypeEnum.none);
	currentBoard.annotation.setShapeType('5');
}

function chooseMouse() {
	currentBoard.annotation.setShapeType(shapeTypeEnum.mouse, './images/mouse.png');
}

function startHlightPoint() {
	currentBoard.annotation.startHlightPoint();
}

function removeBoard() {
	if (currentBoardId && currentBoardUserId == room.selfUser.id) {
		room.selfUser.removeBoardById(currentBoardId);
		removeBoardHandle(currentBoardId);
	}
}

function removeBoardHandle(boardId) {
	var removeBoardDivName = "board_" + boardId;
	var removeBoardsDiv = document.getElementById(removeBoardDivName);

	var boardsDiv = document.getElementById("boardsDiv");
	boardsDiv.removeChild(removeBoardsDiv);
	$('#tag' + boardId).remove('')
	currentBoardUserId = null;
	currentBoardId = null;
	currentBoard = null;
}

function selectToolColorChange() {
	var color = "rgba(" + colorRgb($('#color').val()) + ")";
	currentBoard.annotation.setColor(color);
}

function colorRgb(value) {
	var sColor = value.toLowerCase();
	//十六进制颜色值的正则表达式
	var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/;
	// 如果是16进制颜色
	if (sColor && reg.test(sColor)) {
		if (sColor.length === 4) {
			var sColorNew = "#";
			for (var i = 1; i < 4; i += 1) {
				sColorNew += sColor.slice(i, i + 1).concat(sColor.slice(i, i + 1));
			}
			sColor = sColorNew;
		}
		//处理六位的颜色值
		var sColorChange = [];
		for (var i = 1; i < 7; i += 2) {
			sColorChange.push(parseInt("0x" + sColor.slice(i, i + 2)));
		}
		return sColorChange.join(",") + ",1";
	}
	return sColor;
}

//开启远程协助
function remoteAssistanceStart() {
	var appJosn = {
		cmd: 501,
		fromUserId: clientName,
		content: {
			type: 'call',
			desc: ''
		}
	}
	console.log("=============================remoteAssistanceStart(),appJosn:", appJosn);

	var appJsonStr = JSON.stringify(appJosn);
	var dataArrayBuffer = typeConversionUtil.String2ArrayBuffer(appJsonStr);
	room.sendPrivateData(dataArrayBuffer, clientName).then(function dataSendSuccess(dataMsg) {
		console.log("remoteAssistanceStart(), sendPrivateData()...success ");
	}).otherwise(function dataSendError(error) {
		console.log("remoteAssistanceStart(), sendPrivateData()...error:", error);
		errorPromptShow('开启远程协助操作失败。error:' + error.message + "[" + error.code + "]");
	});
}

//结束远程协助
function remoteAssistanceEnd() {
	var appJosn = {
		cmd: 501,
		fromUserId: clientName,
		content: {
			type: 'close',
			desc: ''
		}
	}
	console.log("=============================remoteAssistanceEnd(),appJosn:", appJosn);

	var appJsonStr = JSON.stringify(appJosn);
	var dataArrayBuffer = typeConversionUtil.String2ArrayBuffer(appJsonStr);
	room.sendPrivateData(dataArrayBuffer, clientName).then(function dataSendSuccess(dataMsg) {
		console.log("remoteAssistanceEnd(), sendPrivateData()...success ");

	}).otherwise(function dataSendError(error) {
		console.log("remoteAssistanceEnd(), sendPrivateData()...error:", error);
		errorPromptShow('关闭远程协助操作失败。error:' + error.message + "[" + error.code + "]");
	});
	remoteAssistanceState = 0;
	setRemoteAssistanceState();
	boardBtn.style.display = 'none';
	removeBoard();

}

// 关闭白板
function closeBoard() {
	var board = room.selfUser.boards[0];
	if (board && board.status == boardStatusEnum.open) {
		removeBoardHandle(room.selfUser.boards[0].id);
		room.selfUser.closeBoardById(room.selfUser.boards[0].id);
	}
}

function removeBoardHandle(boardId) {
	var removeBoardDivName = "board_" + boardId;
	var removeBoardsDiv = document.getElementById(removeBoardDivName);

	var boardsDiv = document.getElementById("boardsDiv");
	boardsDiv.removeChild(removeBoardsDiv);
	$('#tag' + boardId).remove('')
	currentBoardUserId = null;
	currentBoardId = null;
	currentBoard = null;
	currentBoardIdDiv.innerHTML = "";
}

$(function () {
	$("#boardBtn").Tdrag({
		scope: ".business"
	});
})

function createCanvas(videoElement) {
	var canvas = document.createElement('canvas');
	canvas.width = videoElement.videoWidth;
	canvas.height = videoElement.videoHeight;
	canvas.getContext('2d').drawImage(videoElement, 0, 0, canvas.width, canvas.height);
	return canvas;
}

function downloadImage(canvas, downloadName) {
	var href = canvas.toDataURL(); // 获取canvas对应的base64编码
	var a = document.createElement('a'); // 创建a标签
	a.download = downloadName ? downloadName : '视频快照'; // 设置图片名字
	a.href = href;
	a.dispatchEvent(new MouseEvent('click'));
}

function takePhotos() {
	var name = prompt('请输入要保存的图片名称', '视频快照'); // 'canvas绘制图片'为图片默认名
	if (name === "") {
		alert('名字不能为空');
	} else {
		downloadImage(createCanvas(clientVideo), name);
	}
}

function ieTakePhotos(){
	activeX.snapshot(snapshotAreaEnum.customerArea);
}