var serverURL = "dev.3tee.cn:81";

var accessKey = 'SDKdemo_access';
var secretKey = 'SDKdemo_secret';
var accessToken = null;

var roomId = null;
var userId = Math.uuid();
var headId = null;

var AVDEngine = ModuleBase.use(ModulesEnum.avdEngine);  
var avdEngine = new AVDEngine();
avdEngine.initDevice();

var self = this;
var restApi = new RestApi(serverURL);

var userName = 'user' + parseInt(Math.floor(Math.random () * 9000) + 1000);

var roomInfo = {
	1:{isVideoOn : false},2:{isVideoOn : false},3:{isVideoOn : false},4:{isVideoOn : false},5:{isVideoOn : false},6:{isVideoOn : false},"docHead":{isVideoOn:false},"icuHead":{isVideoOn:false}
}



restApi.getAccessToken (accessKey , secretKey).then((res) => {
    console.log('Success',res)
    self.accessToken = res.token;
}).otherwise((error) => {
    console.log("Error",error);
    if(error.ret == 10000) {
    	$(".promptMsg").html(error.msg+ ' 查看协议是否为https,如果是则更换serverURL地址');
    } else {
    	$(".promptMsg").html(error.msg);
    }
})


//引擎初始化
function initSuccess(){
    console.log("引擎初始化成功");
}


function initError(error){
  console.error("引擎初始化失败。error:", error);
}

//创建房间
function createRoom(){
	var topic = "Test";

	restApi.createRoom(self.accessToken, topic, self.userId).then( (res) => {
		roomId = res.room_id;
		$("#room_id").val(roomId);
		self.roomId = roomId;
		roomOwner = self.userId;
		console.log("获取房间成功.roomId:" + roomId);
	}).otherwise( (error) => {
		console.log("获取房间失败。error:" + error);
	}) 
}

//加入房间
function joinRoom() {
	if($('#room_id').val() == ''){
		$('#promptMsg').html('提示信息：会议号不能为空，请先创建房间');
	}else{
		$('#promptMsg').html('');
		self.roomId = $("#room_id").val();
		avdEngine.init(serverURL, accessToken).then(initSuccess).otherwise(initError);
	}
	
}

function initSuccess() {
	room = avdEngine.obtainRoom(roomId);
	room.join(userId, userName, '','').then(joinSuccess).otherwise(joinError);
}

function joinSuccess(){
	console.log("加入房间成功");
	
	//自动打开音视频
	openCamera();
	openMicrophone();
	
	//注册房间回调
	registerRoomCallback();
	
	//加会登陆前，会议中已经发布的视频资源,采取订阅处理
	onPublishCameraNotify(room.pubVideos); 
	participantsHandle(room.getParticipants());
	
	// $("#localVideo_userName").html(self.userName);//名字加上userName
	console.log(room);
}

function joinError(error){
	console.error("加入房间失败。error:" + error);
}

var isOpenVideoShow = true;
var isOpenAudioShow = true;
var localVideoId = '';
var localAudioId = '';

var icuVideoId1 = null;
var icuVideoId2 = null;
var icuVideoId3 = null;
var icuVideoId4 = null;
var icuVideoId5 = null;
var icuVideoId6 = null;

//打开摄像头，自动渲染视频
function openCamera() {
	if (document.getElementById('room').innerHTML == '医生办公室'){
		if (isOpenVideoShow) {
			isOpenVideoShow = false;
			videos = room.selfUser.videos;
			if (videos && videos.length > 0) {
				var video = videos[0];
				localVideoId = video.id;
				video.previewAndPublish(localVideo).otherwise(alertError);
				roomInfo.docHead.isVideoOn = true;
			}
		}
		dataSend("isheadset");
		return;
	}
	if(isOpenVideoShow){
		isOpenVideoShow = false;
		videos = room.selfUser.videos;
		if(videos.length > 4){
			$('.opRoom').css({
				"width": "70%",
				"height":"70%",
				"margin-left":"350px",
				"border": "2px hidden black"
			})
		}
		if(videos && videos.length > 0){
		    for(let i = 1 ;i <= videos.length; i++){
				$('.opRoom').append('<div class="box" id="opRoom' + i + '"><span id="userName'+ i +'" class="userName"></span><video id="icuVideo' + i + '" autoplay muted></video><img src="images/head.png" class="head" id="icuVideoId'+ i +'" alt="设置头像"/><img src="images/fullScreen.png" class="full" alt="全屏"/></div>');
				$('.box').css({
					"float": "left",
					"width":"48%",
					"height":"48%",
					"border": "1px solid #000000",
					"position": "relative",
					"margin": "5px 0 0 5px"
				})
				$('#icuVideo'+i).dblclick(function(){
					doFullScreen(this,this)
				})
				$('#icuVideoId'+i).click(function(){//设置头像的方法
					setHead(this,videos)
				})
				$('.full').click(function(){
					clickFullScreen(this);
					})
				var video = videos[i-1];
				localVideoId = video.id;
				$('#userName'+i).html(video.id.substring(0,8))
				roomInfo[i].isVideoOn = true;
				switch(i){
					case 1:
						video.previewAndPublish(icuVideo1).otherwise(alertError);
						document.getElementById("icuVideoId1").id = video.id;
						break;
					case 2:
						video.previewAndPublish(icuVideo2).otherwise(alertError);
						document.getElementById("icuVideoId2").id = video.id;
						break;
					case 3:
						video.previewAndPublish(icuVideo3).otherwise(alertError);
						document.getElementById("icuVideoId3").id = video.id;
						break;
					case 4:
						video.previewAndPublish(icuVideo4).otherwise(alertError);
						document.getElementById("icuVideoId4").id = video.id;
						break;
					case 5:
						video.previewAndPublish(icuVideo5).otherwise(alertError);
						document.getElementById("icuVideoId5").id = video.id;
						break;
					case 6:
						video.previewAndPublish(icuVideo6).otherwise(alertError);
						document.getElementById("icuVideoId6").id = video.id;
						break;
				}
			};
		}
	}
}

function closeCamera() {
	if(!isOpenVideoShow){
		isOpenVideoShow = true;
		var video = room.selfUser.getVideo(self.localVideoId);
		if(video){
			video.unpreview();
			video.unpublish();
			if (document.getElementById('room').innerHTML == '医生办公室'){
				roomInfo.docHead.isVideoOn = false;
			}
		}
	}
}


function openMicrophone() {
	if(isOpenAudioShow){
		isOpenAudioShow = false;
		var audio = room.selfUser.audio;
		localAudioId = audio.id;
		if(audio){
		    audio.openMicrophone().otherwise(alertError);
		}
	}
}

function closeMicrophone() {
	if(!isOpenAudioShow){
		isOpenAudioShow = true;
		var audio = room.selfUser.getAudio(self.localAudioId);
		if(audio) {
		    audio.closeMicrophone();
		}
	}
}

function alertError(error) {
	$("#promptMsg").html("code:" + error.code + " ;  message:" + error.message);
}

function registerRoomCallback() {
	room.addCallback(RoomCallback.connection_status, onConnectionStatus);
	
	room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
	room.addCallback(RoomCallback.public_data, onPublicData);
	room.addCallback(RoomCallback.private_data, onPrivateData);
	room.addCallback(RoomCallback.user_leave_notify, onUserLeaveNotify);
}

/**
 * @desc 网络状态回调
 */
function onConnectionStatus(status) {
    if(status == ConnectionStatus.connecting) {
		$(".promptMsg").html("网络故障,正在与服务器重连中...");
	} else if(status == ConnectionStatus.connected) {
		//连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reJoinConnected) {
		//重新加会成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.reconnected) {
		//重连接成功
		$(".promptMsg").html("");
	} else if(status == ConnectionStatus.connectFailed) {
		$(".promptMsg").html("网络故障,与服务器重连超时，正在重新加会操作中...");

		//应用层清场
		if(room.connectionInfoCollector) {
			room.connectionInfoCollector.stop(); //停止收集网络情况
		}
	} else if(status == ConnectionStatus.reJoinRoomTimeOut) {
		$(".promptMsg").html("网络故障,重新加会中...");
	    room.continuousReJoin();
	}
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
var self = this;
var icuParticipantId = null;
function onUserJoinNotify(users) {
	participantsHandle(users);
}
function onUserLeaveNotify(opt, reason, user) {
	$(".opRoom div").remove();
}
function onPublishCameraNotify(videos) {
	videos.forEach(function(video) {
		//只订阅未订阅过的视频
		var subVideoIdsLen = room.selfUser.subVideoIds.length;
		if(subVideoIdsLen > 0) {
			var isSub = false;
			for(let i = 0; i < subVideoIdsLen; i++) {
				var videoId = room.selfUser.subVideoIds[i];
				if(video.id == videoId) {
					isSub = true;
					break;
				}
			}
			if(!isSub) {
				video.subscrible();
			}
		} else {
			video.subscrible();
		}
	});
}

function participantsHandle(participants){
	participants.forEach(function (user){
		
		user.addCallback(UserCallback.publish_camera_notify, onPublishCameraNotify);
		user.addCallback(UserCallback.subscrible_camera_result, onSubscribleCameraResult);
		user.addCallback(UserCallback.unpublish_camera_notify, onUnpublishCameraNotify);
		user.addCallback(UserCallback.unsubscrible_camera_result, onUnsubscribleCameraResult);
		
		user.addCallback(UserCallback.publish_microphone_notify, onPublishMicrophoneNotify);
		user.addCallback(UserCallback.subscrible_microphone_result, onSubscribleMicrophoneResult);
	})
}

function onUnpublishCameraNotify(video) {
	video.unsubscrible();
}

/**
 * 取消订阅远端视频流反馈
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 * @param {Object} cameraId－摄像头设备ＩＤ
 */
function onUnsubscribleCameraResult(userId, userName, cameraId) {
    if (document.getElementById('room').innerHTML == '医生办公室'){
		for (let i = 1; i <= 6; i++) {
			if (cameraId == roomInfo[i].cameraId) {
				room.selfUser.attachVideoElementMediaStream(document.getElementById("icuVideo" + i), null);
				roomInfo[i].cameraId = null;
				roomInfo[i].isVideoOn = false;
			}
		}
		return;
	}
	room.selfUser.attachVideoElementMediaStream(remoteVideo, null);
	roomInfo.docHead.isVideoOn = false;
}

var camera = 0;
var paint = true; //是否第一次渲染，设定头像的时候不会重复订阅
function onSubscribleCameraResult(stream, userId, userName, cameraId) {
	// $('#remoteFace').html("用户名："+userName);
	if (document.getElementById('room').innerHTML == '医生办公室'){
		if(paint){
			camera ++;
			if(camera>6) return;
			$('.opRoom').append('<div class="box" id="opRoom' + camera + '"><span id="userName'+ camera +'" class="userName"></span><video id="icuVideo' + camera + '" autoplay muted></video><img class="full" alt="全屏" src="images/fullScreen.png"/></div>');
			$('#icuVideo'+camera).dblclick(function(){
				doFullScreen(this,this)
			})
			$('#userName'+camera).html(cameraId.substring(37,45))
			$('.full').click(function(){
				clickFullScreen(this);
			})
			if(camera > 4){
				$('.box').css({
					"float": "left",
					"width":"32%",
					"height":"48%",
					"border": "0.5% solid #000000",
					"position": "relative"
				})
			}
				
		}
		if (headId != null && cameraId.substring(cameraId.length - 10) == headId.substring(headId.length - 10)) {
			room.selfUser.attachVideoElementMediaStream(document.getElementById("remoteVideo"), stream);
			// $('#remoteFace span').html(cameraId.substring(0,8));  //医生端的监护室头像的名字变成摄像头id前八位
			roomInfo.icuHead.isVideoOn = true;
		}else if (isSetHead){
			room.selfUser.attachVideoElementMediaStream(document.getElementById("remoteVideo"), stream);
			
		}
		for (let i = 1; i <= 6; i++) {
			if (roomInfo[i].isVideoOn == false) {
				room.selfUser.attachVideoElementMediaStream(document.getElementById("icuVideo" + i), stream);
				roomInfo[i].isVideoOn = true;
				roomInfo[i].cameraId = cameraId;
				return;
			}
		}
		return;
	}
	room.selfUser.attachVideoElementMediaStream(remoteVideo, stream);
	roomInfo.docHead.isVideoOn = true;
}

function onPublishCameraNotify(videos) {
	if (document.getElementById('room').innerHTML == '医生办公室'){
		if(videos.length > 4 ){
			$('.opRoom').css({
				"width": "70%", 
				"height":"70%",
				"margin-left":"350px",
				"border": "2px solid black"
			});
		}
	}
	videos.forEach(function(video) {
		//只订阅未订阅过的视频
		var subVideoIdsLen = room.selfUser.subVideoIds.length;
		if(subVideoIdsLen > 0) {
			var isSub = false;
			for(let i = 0; i < subVideoIdsLen; i++) {
				var videoId = room.selfUser.subVideoIds[i];
				if(video.id == videoId) {
					isSub = true;
					break;
				}
			}
			if(!isSub) {
				video.subscrible();
			}
		} else {
			video.subscrible();
		}
	});
}

function onPublishMicrophoneNotify(audios) {
	audios.forEach(function(audio) {
		//只订阅未订阅过的音频
		var subAudioIdsLen = room.selfUser.subAudioIds.length;
		if(subAudioIdsLen > 0) {
			var isSub = false;
			for(let i = 0; i < subAudioIdsLen; i++) {
				var audioId = room.selfUser.subAudioIds[i];
				if(audio.id == audioId) {
					isSub = true;
					break;
				}
			}
			if(!isSub) {
				audio.subscrible();
			}
		} else {
			audio.subscrible();
		}
	});
}

/**
 * 订阅远端音频流反馈
 * @param {Object} stream－ 远端音频流
 * @param {Object} userId－ 所属用户ＩＤ
 * @param {Object} userName－所属用户名称
 */

function onSubscribleMicrophoneResult(stream, userId, userName) {
	// document.getElementById('remote_audio').className = 'openMicrophone';
	room.selfUser.attachAudioElementMediaStream(remoteAudio, stream);
}

function leaveRoom() {
    if(!room){return}
    var close = window.confirm('您确认退出会议?');
	if(close) {
		var reason = 1; //退会原因
		room.leave(reason).then(function() {
		    if (document.getElementById('room').innerHTML == '医生办公室'){
				top.location = "doctor.html";
			}else{
				top.location = "icu.html";
			}
			return false;
		});
		// room.leave(reason).then(function() {
		// 	$('.opRoom div').remove();
		// });
	}
}

var isSetHead = false;
var headVideoId = null;

//设置icu端头像
function setHead(e,videos){
	dataSend("false");
	if(e.id=="icuVideoId1"||e.id=="icuVideoId2"||e.id=="icuVideoId3"||e.id=="icuVideoId4"||e.id=="icuVideoId5"||e.id=="icuVideoId6"){
		return; 
	}
	if(!isSetHead){  //没有设置头像
		isSetHead = true;
		videos.forEach(function(video){
			if(video.id == e.id){
				dataSend(e.id);
				video.unpreview();
				video.unpublish();
				video.previewAndPublish(localVideo).otherwise(alertError);
				// $('#localVideo_userName').html('重症监护室'+video.id.substring(0,8));//名字加上video的编号
				headVideoId = e.id;
				for(let i = 1;i <= 6;i++){
					if(e.parentNode.id == "opRoom" + i){
						e.id = "icuVideoId" + i;
						roomInfo[i].isVideoOn = false;
						roomInfo.icuHead.isVideoOn = true;
						$('#opRoom'+i).remove();
					}
				}
			}
		})
	}else{
		for(let i = 1;i <=6 ; i++){//找到头像视频切换后的位置
			if(e.parentNode.id == "opRoom" + i){
				var replaceRoom = "icuVideo" +i;
			}
		}
		videos.forEach(function(video){//先取消头像视频流的发布，再重新渲染到切换后的位置
			if(video.id == headVideoId){
				video.unpreview();
				video.unpublish();
				
				switch(replaceRoom){
					case "icuVideo1":
					video.previewAndPublish(icuVideo1).otherwise(alertError);
					$('#opRoom1 span').html(video.id.substring(0,8));
					break;
					case "icuVideo2":
					video.previewAndPublish(icuVideo2).otherwise(alertError);
					$('#opRoom2 span').html(video.id.substring(0,8));
					break;
					case "icuVideo3":
					video.previewAndPublish(icuVideo3).otherwise(alertError);
					$('#opRoom3 span').html(video.id.substring(0,8));
					break;
					case "icuVideo4":
					video.previewAndPublish(icuVideo4).otherwise(alertError);
					$('#opRoom4 span').html(video.id.substring(0,8));
					break;
					case "icuVideo5":
					video.previewAndPublish(icuVideo5).otherwise(alertError);
					$('#opRoom5 span').html(video.id.substring(0,8));
					break;
					case "icuVideo6":
					video.previewAndPublish(icuVideo6).otherwise(alertError);
					$('#opRoom6 span').html(video.id.substring(0,8));
					break;
				}
			}
		})
		videos.forEach(function(video){//所点击的div中的视频流渲染到头像框内
			if(video.id == e.id){
				dataSend(e.id);
				video.unpreview();
				video.unpublish();
				video.previewAndPublish(localVideo).otherwise(alertError);
				// $('#localVideo_userName').html('重症监护室'+video.id.substring(0,8));//名字加上video的id
				var temp = headVideoId;//更新头像的cameraId
				headVideoId = e.id;
				e.id = temp;
				throw new Error("终止遍历")//不终止会出现bug
			}
		})
	}
}

/**
 * @desc 控件全屏初始化
 */
function fullScreenInit() {
	 document.cancelFullScreen = document.webkitCancelFullScreen ||  document.mozCancelFullScreen || document.cancelFullScreen;

     document.body.requestFullScreen = document.body.webkitRequestFullScreen || document.body.mozRequestFullScreen || document.body.requestFullScreen;

     document.onfullscreenchange = document.onwebkitfullscreenchange = document.onmozfullscreenchange = displayFullScreenStatus;
     
     displayFullScreenStatus(); // on load
}
fullScreenInit();
/**
 * @desc 控件全屏操作
 * @param {Object} element - 控件
 * @param {Object} e - ondblclick返回值
 */
function doFullScreen(element,e){
	element.requestFullScreen = element.webkitRequestFullScreen || element.mozRequestFullScreen || element.requestFullScreen;

	if ((isFullScreen() && e.target !== element) ||  fullScreenElement() === element) {
		 document.cancelFullScreen();
	 } else {
		 element.requestFullScreen();
	 }
}

function displayFullScreenStatus(){
	 var status = isFullScreen(); //当前的状态
}

function isFullScreen(){
	return !!(document.webkitIsFullScreen || document.mozFullScreen || document.isFullScreen); // if any defined and true
}

function fullScreenElement(){
	return document.webkitFullScreenElement || document.webkitCurrentFullScreenElement || document.mozFullScreenElement || document.fullScreenElement;
}

function clickFullScreen(element){
	if(element.parentNode.id == "localFace" && roomInfo.icuHead.isVideoOn == true){//医生头像、监护室头像和监护室其他视频分开讨论
		var targetNode = document.getElementById("localVideo");
		doFullScreen(targetNode,targetNode);
		return;
	}else if(element.parentNode.id == "remoteFace" &&roomInfo.docHead.isVideoOn == true){
		var targetNode = document.getElementById("remoteVideo");
		doFullScreen(targetNode,targetNode);
		return;
	}else if(element.parentNode.id == "localFace" && roomInfo.docHead.isVideoOn == true) {
		var targetNode = document.getElementById("localVideo");
		doFullScreen(targetNode, targetNode);
		return;
	} else if (element.parentNode.id == "remoteFace" && roomInfo.icuHead.isVideoOn == true) {
		var targetNode = document.getElementById("remoteVideo");
		doFullScreen(targetNode, targetNode);
		return;
	}
	
	for(let i = 1;i <= 6;i++){
		if(element.parentNode.id == "opRoom" + i){
			if(roomInfo[i].isVideoOn == false) break;
			var targetVideo = "icuVideo" + i;
			var targetNode = document.getElementById(targetVideo);
			doFullScreen(targetNode,targetNode)
			return;
		}
	}
}

//透明通道发送信息
function dataSend(msg) {
	var dataUserId;
	var dataMsg = msg;
	
	room.participants.forEach(function(participant){
		if(participant.id != room.selfUser.id){
			dataUserId = participant.id;
		}
	})
	if(strUtil.isEmpty(dataMsg)) {
		return;
	} else {
		var dataArrayBuffer = typeConversionUtil.String2ArrayBuffer(dataMsg);
		if(strUtil.isEmpty(dataUserId)) {
			room.sendPublicData(dataArrayBuffer).then(dataSendSuccess(dataMsg)).otherwise(dataSendError);
		} else {
			room.sendPrivateData(dataArrayBuffer, dataUserId).then(dataSendSuccess(dataMsg)).otherwise(dataSendError);
		}
	}
	
}

function dataSendSuccess(dataMsg) {

}

function dataSendError(error) {

}

/**
 * 字符串相关处理
 */
var strUtil = {
	/*
	 * 判断字符串是否为空
	 * @param str 传入的字符串
	 * @returns {}
	 */
	isEmpty: function(str) {
		if(str != null && str.length > 0) {
			return false;
		} else {
			return true;
		}
	}
}

/**
 * 公有透明通道回调
 * @param {Object} dataArrayBuffer － DataArrayBuffer对象
 * @param {String} userId － user id
 */
function onPublicData(dataArrayBuffer, userId) {
	fillDataElement(dataArrayBuffer, userId);
}

/**
 * 私有透明通道回调
 * @param {Object} dataArrayBuffer － DataArrayBuffer对象
 * @param {String} userId － user id
 */
function onPrivateData(dataArrayBuffer, userId) {
	fillDataElement(dataArrayBuffer, userId);
}

function fillDataElement(dataArrayBuffer, userId) {
	if (document.getElementById('room').innerHTML == '医生办公室'){
		var content = typeConversionUtil.ArrayBuffer2String(dataArrayBuffer);
		if(content == "false"){
			paint = false;
		}else if(content == "headtrue"){
			isSetHead = true;
		} else{
			headId = content;
		}
		return;
	}
	var content = typeConversionUtil.ArrayBuffer2String(dataArrayBuffer);
	if(content == "isheadset"){
		if(isSetHead == true){
			dataSend("headtrue")
		}else{
			return;
		}
	}
}

