var shareVideo = document.getElementById("shareVideo");

var jumpA = document.getElementById("jumpA");

document.getElementById("openDesktopShared").disabled = 'ture';
document.getElementById("exitMeeting").disabled = 'ture';


//创建房间
function createRoom() {
    $(".prompt p").html('')
    var topic = 'testingMeeting';
    restApi.createRoom(self.accessToken, topic, self.userId).then((res) => {
        $("#first").val(res.room_id);
    }).otherwise((error) => {
        $(".prompt p").html('createRoom(),error:'+error.msg);
    })
}

//  点击加入房间
function joinRoom() {
    if (room) { return }
    if ($("#first").val() == '') {
        $(".prompt p").html('会议号不能为空，建议请先创建房间');
    } else {
        self.roomId = $("#first").val();
        avdEngine.init(self.serverURL, self.accessToken).then(initSuccess).otherwise(initError);
    }
}

//  初始化成功
function initSuccess() {
    room = avdEngine.obtainRoom(roomId);
    room.join(userId, userName, '', '').then(joinSuccess).otherwise(joinError);
    $(".prompt p").html('');
}

//  初始化失败
function initError(error) {
    console.log(error)
    $(".prompt p").html("AVDEngine 初始化失败！initError(),error:" + error.message);
}

//  加入房间成功
function joinSuccess() {
    console.log('加入会议成功');

    //房间回调
    registerRoomCallback();

    onPublishScreenNotify(room.pubScreens);
    participantsHandle(room.getParticipants());

    document.getElementById("joinMeeting").disabled = '';
    document.getElementById("joinMeeting").className = 'unclickable';
    document.getElementById("openDesktopShared").disabled = '';
    document.getElementById("openDesktopShared").className = 'clickable';
    document.getElementById("exitMeeting").disabled = '';
    document.getElementById("exitMeeting").className = 'clickable';
}

//  加入房间失败
function joinError(error) {
    $(".prompt p").html(error.message);
}

function alertError(error) {
    console.log("============================alertError", error)
    $(".prompt p").html('alertError(),error:'+ error.message);
}

/**
 * 注册房间级别的回调
 */
function registerRoomCallback() {
    room.addCallback(RoomCallback.connection_status, onConnectionStatus);
    room.addCallback(RoomCallback.screen_sharing_ended, onScreenSharingEnded);

    room.addCallback(RoomCallback.user_join_notify, onUserJoinNotify);
}

/**
 * @desc 参会者加会回调
 * @param {Object} users － 参会者数组
 */
function onUserJoinNotify(users) {
	participantsHandle(users);
}

//  网络状态
function onConnectionStatus(status) {
    console.log("=====================onConnectionStatus()", status)
    if (status == ConnectionStatus.connecting) {
        $(".prompt p").html("网络故障,正在与服务器重连中...");
    } else if (status == ConnectionStatus.connected) {
        //连接成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.reJoinConnected) {
        //重新加会成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.reconnected) {
        //重连接成功
        $(".prompt p").html("");
    } else if (status == ConnectionStatus.connectFailed) {
        $(".prompt p").html("网络故障,与服务器重连超时，正在重新加会操作中...");
    } else if (status == ConnectionStatus.reJoinRoomTimeOut) {
        $(".prompt p").html("网络故障,重新加会中...");
    }
}

// 桌面共享关闭的回调
function onScreenSharingEnded() {
    
}

//  打开桌面共享
function openScreenAndPub() {
    if (!room) { return }
    screen = room.selfUser.getScreen();
    console.log("========================================", screen.id)
    if (screen) {
        screen.publish().then(function () {
            console.log('=============openScreenAndPub(),桌面共享成功==========');
            screen.preview(shareVideo);
            jumpA.style.display = 'inline-block';
            jumpA.href = './receptionScreen.html?roomId=' + roomId;

        }).otherwise(alertError);

        document.getElementById("openDesktopShared").disabled = 'ture';
        document.getElementById("openDesktopShared").className = 'unclickable';
    }
}

function participantsHandle(participants) {
    participants.forEach(function(user) {
        user.addCallback(UserCallback.publish_screen_notify, onPublishScreenNotify);
		user.addCallback(UserCallback.unpublish_screen_notify, onUnpublishScreenNotify);
		user.addCallback(UserCallback.subscrible_screen_result, onSubscribleScreenResult);
		user.addCallback(UserCallback.unsubscrible_screen_result, onUnsubscribleScreenResult);
    })
}

function onPublishScreenNotify(screens) {
	screens.forEach(function(screen) {
		//只订阅未订阅过的桌面共享
		var subScreenIdsLen = room.selfUser.subScreenIds.length;
		if(subScreenIdsLen > 0) {
			for(var i = 0; i < subScreenIdsLen; i++) {
				var screenId = room.selfUser.subScreenIds[i];
				if(screen.id == screenId) {
					isSub = true;
					break;
				}
			}
			if(!isSub) {
				screen.subscrible();
			}
		} else {
			screen.subscrible();
		}
	});
}

function onUnpublishScreenNotify(screen) {
	screen.unsubscrible();
}

function onSubscribleScreenResult(stream, userId, userName, screenId, width, height,framerate) {
	console.log("=======onSubscribleScreenResult(),width:"+  width + ",height:" + height+",framerate:"+framerate);
	room.selfUser.attachScreenElementMediaStream(shareVideo, stream);
}

function onUnsubscribleScreenResult(userId, userName, screenId) {
	room.selfUser.attachScreenElementMediaStream(shareVideo, null);
}

/**
 *  退出会议室
 */
function closeRoom() {
    if (!room) { return }
    var close = window.confirm('您确认退出会议?');
    if (close) {
        var reason = 1; //退会原因
        room.leave(reason).then(function () {
            top.location = "index.html";
            return false;
        });
    }
}